Attribute VB_Name = "BigInt_Functions_5"
Option Explicit
'
'------------------------------------------------------------------------------
'  VBAő{Zs߂̃Cup  Z֐T
'    WW[ BigInt_Definition_1`3   K{
'    WW[ BigInt_Definition_SWTAPI K{
'    WW[ BigInt_Functions_1 `4   K{
'    WW[ BigInt_Functions_FFT     K{
'------------------------------------------------------------------------------
'
'pubN萔
Public Const LogLimitN As Long = 1000000     'Rΐ  ȗ̓vZ(For`Next)
'------------------------------------------------------------------------------
'pubNϐ
'------------------------------------------------------------------------------
'vCx[g萔
'------------------------------------------------------------------------------
'vCx[gϐ
'------------------------------------------------------------------------------
'
'̃W[̊֐ꗗ
'------------------------------------------------------------------------------
' ======= Sub ֐ ===============================================
' ======= Function ֐ ==========================================
'    Rΐ  BILnX(A As BigIntType, Optional Digit As Variant, Optional N As Long = LogLimitN, _
'                    Optional debug_ As Variant, Optional debug2_ As Variant, Optional debug3_ As Variant) As BigIntType
'  ******ixj**************************************
'    Rΐ  BILnX2(A As BigIntType, Optional Digit As Variant, Optional N As Long = LogLimitN, _
'                     Optional debug_ As Variant, Optional debug2_ As Variant, Optional debug3_ As Variant) As BigIntType
'------------------------------------------------------------------------------
'
'ỹW[̍XVz
'       ɂ            o[W                                  XVe
' ---------------+----------------------------------+---------+-----------------------------------------------------------------------------------
'    [2010/02/14] Ver.1.89 Alpha EditioniJŁj      X  Rΐ(BILnX)  ΐ̍œK(𑬂߂)
'                                                         X  Rΐ(BILnX,BILnX2)  For`Next
'                                                     ɘa  pubN萔  Rΐ  ȗ̓vZ LogLimitN(100000010000)
'                                                     C      Rΐ(BILnX,BILnX2)  vZق
'    [2009/11/10] Ver.1.86 Alpha EditioniJŁj  Pp  Rΐ(BILnX,BILnX2)  Z̐Pp (pubN萔:LogN)
'                                                     Pp  Rΐ(BILnX,BILnX2)  vZ񐔂̐Ppiȍ~͈ȗ̌vZ񐔂̂Ă̂ݎgpj
'    [2008/12/10] Ver.1.73 Alpha EditioniJŁj  ɘa  pubN萔  Rΐ  LogN(100000010000)
'    [2008/10/05] Ver.1.67 Alpha EditioniJŁj      X  Rΐ(BILnX,BILnX2)  @
'    [2008/06/30] Ver.1.61 Alpha EditioniJŁj  C      Rΐ(BILnX,BILnX2)  G[኱
'    [2008/06/14] Ver.1.51 Alpha EditioniJŁj  C      Rΐ(BILnX,BILnX2)  őJԂvZ̏(Exit For)
'    [2008/06/10] Ver.1.28 Alpha EditioniJŁj      X  Rΐ֐ (BILnXBILogX, BILnX2BILogX2)
'    [2008/06/09] Ver.1.24 Alpha EditioniJŁj         KetaN ȗ̐ݒ蔲iBILnX, BILnX2jق
'                                                     C      Rg
'    [2008/06/05] Ver.1.02 Alpha EditioniJŁj        X>2
'    [2008/06/05] Ver.0.98 Alpha EditioniJŁj  VKǉ
'------------------------------------------------------------------------------
'  ӎ
'    ẼW[݂̂ł͍쓮ł܂
'      VBAő{Zs߂̃Cu(BigInt_Definition_1`2,BigInt_Functions_1)Kvł
'    E}[N ,  ́Aȗ\ debug_, debug2_, debug3_ 
'      폜ꍇ̖ڈł
'------------------------------------------------------------------------------
'

'Rΐ
Public Function BILnX(A As BigIntType, Optional Digit As Variant, Optional N As Long = LogLimitN, _
                      Optional debug_ As Variant, Optional debug2_ As Variant, Optional debug3_ As Variant) As BigIntType
'  Log X  Rΐ e [Log e(X)=2*(1/(2*k+1))((X-1)/(X+1))^(2*k+1)]  ( 0<X<=2)
'------------------------------------------------------------------------------
'    A:        [BigIntType]       Rΐ߂f[^
'        Digit:    [Variant/Long]     iȗj߂錅        iȗ A ̌j
'        N         [Long]             iȗjőJԂvZ (ȗ pubN萔 LogLimitN)
'        debug_    [Variant/Object]   iȗj[U[tH[̃IuWFNg  vZߒ̏o͐
'        debug2_   [Variant/Object]   iȗj[U[tH[̃IuWFNg  vZԂ̏o͐
'  ߒl  I  [BigIntType]       Rΐ
'@@  @ُI  [BigIntType]       [U[`^̃G[l (BigSgn:""(ASCIIR[hԍ0), BigInt:"", BigExp:0, BigDat:Empty)
'------------------------------------------------------------------------------
'    ̎Rΐ̊֐́Aΐ̖@ŁA
'        o邾Pɋ߂lɕϊAœKijċ߂܂
'          ΐ̖@
'           (1) Log(X^M)=M*(Log(X))
'           (2) Log(X*e^M/e^M)=Log(X*e^M)+(Log(1/e^M)
'                             =Log(X*e^M)-(Log(e^M))
'                             =Log(X*e^M)-M*Log(e)
'                             =Log(X*e^M)-M
'------------------------------------------------------------------------------
'    X > 0
'        ȗ̌vZ:LogLimitN=1000000
'------------------------------------------------------------------------------
'  ˑ  ֐  BISqr, BIE,
'              BICBit, BigIntAdd, BigIntSub, BigIntMul, BigIntDiv,
'              BIIsError, BIIsAEqualB, BIIsBOrMore, Bigint2String, BIKetaN,
'              BIWarnningDialog,
'              DigitCheck, SetBigIntDigitCalculations,
'              Wait
'        萔  BigIntLimit,DefaultDigit, LogLimitN
'        ϐ  DefaultDigit2, BigIntErrFLG,
'              NowTime, LastTime
'  ̃Xg͒ڗpĂ֐E萔Eϐ̂݁iVBAg݊֐E萔j
'------------------------------------------------------------------------------
'    ݂̂obł́A2147483647(=BigIntLimit)܂ŋ߂͖̂ł
'        px̉ZXs[hȂ΁A߂錅1000000ȉŎgpĂ
'
'         Digit ͏ȗ\A߂錅ƂĕK{
'------------------------------------------------------------------------------
'  Ql@vZԁ@mF
'------------------------------------------------------------------------------
Dim AA        As BigIntType   'Copy
Dim CC        As BigIntType   '
Dim X0        As BigIntType   '萔  0
Dim X1        As BigIntType   '      1
Dim X2        As BigIntType   '      2
Dim X3        As BigIntType   '      3
Dim X10       As BigIntType   '     10
Dim d         As BigIntType   '(X-1)^n
Dim DD        As BigIntType   '(X-1)
Dim f         As BigIntType   '1/k
Dim MM1       As BigIntType   'X͂oW [Log(X^M)=M*(Log(X))]
Dim MM2       As BigIntType   'X͂oWQ [Log(X*e^M/e^M)=Log(X*e^M)-M]
Dim MM3       As BigIntType   'X͂oWR [Log(X^M)=M*(Log(X))]
Dim TMP       As BigIntType   'vZ̉l
Dim TMP2      As BigIntType   '
Dim TMP3      As BigIntType   '
Dim X0L0      As BigIntType   '萔 1+(10^(-L))
Dim BLog0     As BigIntType   'Oil(X-1)/(X+1)j
Dim BLogN     As BigIntType   'm
Dim BLog1     As BigIntType   'Pȍ~݌v  ̐
Dim I         As Long         '
Dim K         As Long         '
Dim L         As Long         '萔̎w (2^L)
Dim M         As Long         'vZ
Dim M2        As Long         'vZ2 <Max:3*Digit>
Dim dE        As Long         'liOƌvŽj
Dim DL1       As Long         '
Dim Ddm       As Long         ']Ti錅j[Decision-digit margin]
Dim Nnow      As Long         '݂̌vZߒo
Dim NlAst     As Long         'ǑvZߒo
Dim dDigit    As Long         ']T
Dim DigitL    As Long         '=Digit
Dim dStepN    As Long         'o͕px
Dim ExpMax    As Long         '萔̎w Max
Dim ExpMin    As Long         '             Min
Dim BLimit_2  As Long         'BigIntLimit / 2
Dim DigitD    As Double       '=Digit
Dim dM2       As Double       'vZ M2 ̊
Dim ddDigit   As Double       ']T dDigit ̊
'
Dim OldTime As Single
Dim DebugTxt As String
    On Error GoTo ERR:
    '
    If Not IsMissing(debug2_) Then Call BI_debug2(debug2_, 0#, OldTime)
    '
    BigIntErrFLG = False
    If BIIsError(A) Then
    '`FbN
        BigIntErrFLG = 5     'uvV[W̌ĂяoA܂͈słBv
        Error BigIntErrFLG
    ElseIf N <= 0 Then
    'őJԂvZ `FbN
        BigIntErrFLG = 5
        Error BigIntErrFLG
    Else
        '߂錅
        If Not DigitCheck(Digit) Then Exit Function
        '
        AA = A
        Call CutLastZero(AA)
        '
        DigitL = CLng(Digit)
        DigitD = CDbl(Digit)
        '萔
        X0 = BICBit(0)
        X1 = BICBit(1)
        X2 = BICBit(2)
        X3 = BICBit(3)
        X10 = BICBit(10)
        '
        Ddm = 1       ']T
        dStepN = 10   'o̓Xebv
        '===============================================
        '
        dM2 = 0.25        '25.0%
        ddDigit = 0.005   ' 0.5%
        ']T
        dDigit = 5 + CLng(ddDigit * DigitD)
        'vZ
        M = SetBigIntDigitCalculations(DigitL, dDigit)
        'vZ M2
        If BigIntLimit - M <= DigitL Then
            M2 = BigIntLimit
        Else
            I = BIMaxV(CLng(dM2 * DigitD), 5)
            If BigIntLimit - M <= I Then
                M2 = BigIntLimit
            Else
                M2 = M + I
            End If
            BLimit_2 = CLng(CDbl(BigIntLimit - dDigit) / (1 + dM2))
            If Len(AA.BigInt) >= BLimit_2 Then
                DL1 = BigIntLimit
            Else
                DL1 = CLng((1 + dM2) * CDbl(Len(AA.BigInt))) + dDigit
            End If
            M2 = BIMaxV(DL1, M2)
            'M2 Max ߂錅R
            If M2 / DigitL > 3 Then
                M2 = 3 * DigitL
            End If
        End If
        '===============================================
        MM1 = X1
        MM2 = X0
        MM3 = X1
        '萔̎w
        ExpMin = 5
        ExpMax = 15
        L = BIMinV(BIMaxV(Len(AA.BigInt), ExpMin), ExpMax)
        '1+(10^(-L))
        X0L0 = X1
        X0L0.BigExp = -1 * L
        X0L0 = BigIntAdd(X0L0, X1)
        'Z\͈̓`FbN
        If BIIsBOrMore(X0, AA) Then
        '0>=A
            BigIntErrFLG = 5
            Error BigIntErrFLG
        Else
            'WJ̌ XKp͈͂QȉȂ̂ŁA
            'ΐ̖@ [Log(X^M)=M*(Log(X))] XQȉ
            If BIIsBOrMore(AA, X2) Then
            'A>=2
                TMP = AA
                I = 0
'''
                '
                If Not IsMissing(debug_) Then DebugTxt = " " & vbCr & _
                                                         "   QȉɑO (2)" & vbCr & _
                                                         "---------------------------" & vbCr
                If Not IsMissing(debug_) Then Call BI_debug1(debug_, DebugTxt, 0.00001)
                '
                Do
                    'M=2ÂOɏo
                    TMP = BISqr(TMP, M2, BsqrLimitC, True)
                    I = I + 1
                    '
                    If Not IsMissing(debug_) Then Call BI_debug1(debug_, "", 0#)
                    '
                Loop While BIIsBOrMore(TMP, X2)   'TMP>=2 TMPQLoopI
                MM1 = BIPowersI(X2, BICBit(I), M2)
''' <ɔ׉Z񐔂͏Ȃg[^Ԃ͑^J̌olō͂܂>
'''                '
'''                If Not IsMissing(debug_) Then DebugTxt = " " & vbCr & _
'''                                                         "   QȉɑO (3)" & vbCr & _
'''                                                         "---------------------------" & vbCr
'''                If Not IsMissing(debug_) Then Call BI_debug1(debug_, DebugTxt, 0.00001)
'''                '
'''                '<vZ M2>
'''                Do
'''                    'M=3ÂOɏo
'''                    TMP = BICub(TMP, M2, BcbcLimitC, True)
'''                    I = I + 1
'''                    '
'''                    If Not IsMissing(debug_) Then Call BI_debug1(debug_, "", 0#)
'''                    '
'''                Loop While BIIsBOrMore(TMP, X2)   'TMP>=2 TMPQLoopI
'''                MM1 = BIPowersI(X3, BICBit(I), M2)
                '
                AA = TMP
                '
                If Not IsMissing(debug_) Then DebugTxt = "---------------------------" & vbCr & _
                                                         " MM1(x): " & Bigint2String(MM1) & " "
                If Not IsMissing(debug_) Then Call BI_debug1(debug_, DebugTxt, 0.00001)
                '
            ElseIf BIIsBOrMore(X1, AA) Then
            '1>=A
            'ΐ̖@ [Log(X*e^M/e^M)=Log(X*e^M)+(Log(1/e^M)=Log(X*e^M)-(Log(e^M))=Log(X*e^M)-M*Log(e)=Log(X)-M]
            'ň̒l1ȏ
                '
                If Not IsMissing(debug_) Then DebugTxt = "   X PȏɑO" & vbCr & _
                                                         "---------------------------" & vbCr
                If Not IsMissing(debug_) Then Call BI_debug1(debug_, DebugTxt, 0.00001)
                '
                TMP = BIE(M, True)   'pubNϐ BeC Ɋi[
                TMP = AA
                I = 0
                'UNIT:100
                If BIIsBlargerA(X0L0, TMP) Then
                '1+(10^(-L))>TMP
                    TMP2 = BIPowersI(BeC, BICBit(L), M)   'e^L
                    Do
                        I = I + L
                        TMP = BigIntMul(TMP, TMP2, M)
                    Loop While BIIsBOrMore(X0L0, TMP)     '(1+(10^(-L)))>=TMP
                End If
                'UNIT:1
                Do While BIIsBOrMore(X1, TMP)             'X1>=TMP
                    I = I + 1
                    TMP = BigIntMul(TMP, BeC, M)
                Loop
                'vZ
                '<vZ M2>
                TMP = AA
                TMP2 = BIPowersI(BeC, BICBit(I), M2)
                AA = BigIntMul(TMP, TMP2, M2)
                MM2 = BICBit(CStr(-1 * I))
                '
                If Not IsMissing(debug_) Then DebugTxt = "---------------------------" & vbCr & _
                                                         " MM2(+): " & Bigint2String(MM2) & vbCr & _
                                                         " X(T): " & BI2ExpN(AA, 16) & vbCr
                If Not IsMissing(debug_) Then Call BI_debug1(debug_, DebugTxt, 0.00001)
                '
            End If
            '
            'ɂPɋ߂Â
            'ΐ̖@ [Log(X^M)=M*(Log(X))]
            If BIIsBOrMore(AA, X0L0) Then   'AA(1+(10^(-L)))ȏ
                TMP = AA
                I = 0
                '
                If Not IsMissing(debug_) Then DebugTxt = " " & vbCr & _
                                                         "   Pɋ߂ÂO" & vbCr & _
                                                         "    L(萔̎w (10^(-L)): " & CStr(L) & vbCr & _
                                                         "    X0L0(萔): " & BI2ExpN(X0L0, 32) & vbCr & _
                                                         "    M2(vZ): " & CStr(M2) & vbCr & _
                                                         "---------------------------" & vbCr
                If Not IsMissing(debug_) Then Call BI_debug1(debug_, DebugTxt, 0.00001)
                '
                '<vZ M2>
'''
                Do
                    'M=2ÂOɏo
                    TMP = BISqr(TMP, M2, BsqrLimitC, True)
                    I = I + 1
                    '
                    If Not IsMissing(debug_) Then Call BI_debug1(debug_, "", 0#)
                    '
                Loop While BIIsBOrMore(TMP, X0L0)   'TMP>=(1+(10^(-L))) TMP(1+(10^(-L)))LoopI
                MM3 = BIPowersI(X2, BICBit(I), M2)
''' <ɔ׉Z񐔂͏Ȃg[^Ԃ͑^J̌olō͂܂>
'''                Do
'''                    'M=3ÂOɏo
'''                    TMP = BICub(TMP, M2, BcbcLimitC, True)
'''                    I = I + 1
'''                    '
'''                    If Not IsMissing(debug_) Then Call BI_debug1(debug_, "", 0#)
'''                    '
'''                Loop While BIIsBOrMore(TMP, X0L0)   'TMP>=(1+(10^(-L))) TMP(1+(10^(-L)))LoopI
'''                MM3 = BIPowersI(X3, BICBit(I), M2)
                '
                If Not IsMissing(debug_) Then DebugTxt = "---------------------------" & vbCr & _
                                                         " MM3(x): " & Bigint2String(MM3) & " "
                If Not IsMissing(debug_) Then Call BI_debug1(debug_, DebugTxt, 0.00001)
                '
                AA = TMP
            End If
            '
            '
            If Not IsMissing(debug_) Then DebugTxt = "---------------------------" & vbCr & _
                                                     " K : vZ" & vbCr & _
                                                     " N : vZ̉l (Pȍ~) ܂" & vbCr & _
                                                     " L : vZ̉liPȍ~j̗L" & vbCr & _
                                                     " T : vZ" & vbCr & _
                                                     "---------------------------" & vbCr & _
                                                     " ߂錅: " & CStr(CLng(Digit)) & vbCr & _
                                                     " ]@T@: " & CStr(dDigit) & vbCr & _
                                                     " v@Z@: " & CStr(CLng(Digit) + dDigit) & " [߂錅{]T]" & vbCr & _
                                                     "---------------------------" & vbCr & _
                                                     " WJɎgpX(T): " & BI2ExpN(AA, 16) & vbCr
            If Not IsMissing(debug_) Then Call BI_debug1(debug_, DebugTxt, 0.00001)
            '
            '<vZ M2>
            TMP = BigIntSub(AA, X1, M2)        'q
            TMP2 = BigIntAdd(AA, X1, M2)       '
            BLog0 = BigIntDiv(TMP, TMP2, M2)   'l(X-1)iOj
            BLog1 = X0                         'Pȍ~
            d = BLog0                          '(X-1)^n
            DD = BigIntMul(BLog0, BLog0, M2)   '((X-1)/(X+1))^2
            '
            'ڍׂȉߒo
            If Not IsMissing(debug3_) Then Call BI_debug1(debug_, "K:0, " & Bigint2String(BLog0) & vbCr, 0.00001)
            '
            'uG[`FbNvXLbv
            ErrorCheckSkipFLG = True
            '[Log e(X)=2*(1/(2*k+1))((X-1)/(X+1))^(2*k+1)]
            For K = 1 To N
            'Pȍ~ vZ
                '---------------------------------------------------------------
                '((X-1)/(X+1))^(2*k+1)
                TMP = BigIntMul(d, DD, M2)
                d = TMP
                '1/(2*k+1)
                f = BigIntDiv(X1, BICBit(2 * K + 1), M2)
                '--------------------------------------------------------
                'jivZl^j
                BLogN = BigIntMul(d, f, M2)
                '------------------------------------------------------------
                'Z
                BLog1 = BigIntAdd(BLog1, BLogN, M2)
                'l Zo
                dE = (Len(BLog0.BigInt) + BLog0.BigExp) - (Len(BLogN.BigInt) + BLogN.BigExp)
                '------------------------------------------------------------
                '
                'ڍׂȉߒo
                If Not IsMissing(debug3_) Then Call BI_debug1(debug_, "K:" & CStr(K) & ", " & Bigint2String(BLog1) & vbCr, 0.001)
                '
                If K Mod dStepN = 0 Then
                    'WaitCPUƐ肵Ȃׂ̂̂Ȃ̂ō폜ȂI
                    Call Wait(0.0001)   'DoEvents
                    '
                    If Not IsMissing(debug_) Then
                        Nnow = dE
                        If Nnow > NlAst + 1 Then
                            DebugTxt = "K:" & CStr(K) & _
                                       ", N:" & Format(NlAst + 1, "00") & "`" & Format(Nnow, "00") & _
                                       ", L:" & Len(BLog1.BigInt) & _
                                       ", T:" & Format(NowTime - OldTime, "#0.000 Sec") & vbCr
                        Else
                            DebugTxt = "K:" & CStr(K) & _
                                       ", N:" & Format(Nnow, "00") & _
                                       ", L:" & Len(BLog1.BigInt) & _
                                       ", T:" & Format(NowTime - OldTime, "#0.000 Sec") & vbCr
                        End If
                        NlAst = Nnow
                    End If
                    If Not IsMissing(debug_) Then Call BI_debug1(debug_, DebugTxt, 0.00001)
                    If Not IsMissing(debug2_) Then Call BI_debug2(debug2_, 0.00001, OldTime)
                    '
                End If
                ' -----------------------------------------------------------
                If dE >= Digit + Ddm Then
                '
                    '
                    If Not IsMissing(debug_) Then
                        Nnow = dE
                        DebugTxt = "l 1E+" & CStr(Digit + Ddm) & "(*) ̂PȉƂȂ܂B" & vbCr & _
                                   "El(O) [" & BI2ExpN(BLog0, 8) & "]" & vbCr & _
                                   "E" & CStr(K) & " T[" & BI2ExpN(BLogN, 8) & "]" & vbCr & _
                                   "(*):߂錅{]T [=" & CStr(Digit) & "+" & CStr(Ddm) & "]" & vbCr & _
                                   "lƔfČvZI܂B" & vbCr & _
                                   "I" & vbCr & _
                                   "K:" & CStr(K) & _
                                   ", N:" & Format(Nnow, "00") & _
                                   ", L:" & Len(BLog1.BigInt) & _
                                   ", T:" & Format(NowTime - OldTime, "#0.000 Sec") & vbCr
                    End If
                    If Not IsMissing(debug_) Then Call BI_debug1(debug_, DebugTxt, 0.00001)
                    If Not IsMissing(debug2_) Then Call BI_debug2(debug2_, 0.00001, OldTime)
                    '
                    Exit For
                End If
            Next K
            'uG[`FbNvXLbvɖ߂
            ErrorCheckSkipFLG = False
            '
            If K > N Then
            'őJԂvZ
                If Not IsMissing(debug_) Then
                    DebugTxt = "----------------------------------" & vbCr & _
                               "̓r BLog0+BLog1:" & Bigint2String(BigIntAdd(BLog0, BLog1, Digit)) & vbCr & _
                               "----------------------------------" & vbCr & _
                               "Pȍ~̍v BLog1:" & Bigint2String(BLog1) & vbCr & _
                               "----------------------------------" & vbCr & _
                               "O BLog0:" & Bigint2String(BLog0) & vbCr & _
                               "----------------------------------" & vbCr & _
                               "őJԂvZ񐔁ilj [N:" & CStr(N) & "] ɒB܂B" & vbCr & _
                               "JԂvZ͎ɏI܂B " & vbCr
                End If
                If Not IsMissing(debug_) Then Call BI_debug1(debug_, DebugTxt, 0.00001)
                If Not IsMissing(debug2_) Then Call BI_debug2(debug2_, 0.00001, OldTime)
            End If
            '
            '̌vZiO{Pȍ~̍vj
            TMP = BigIntAdd(BLog0, BLog1, M)   '+
            TMP2 = BigIntMul(TMP, X2, M)       'x2
            TMP3 = BigIntMul(TMP2, MM3, M)     'xMM3
            TMP = BigIntAdd(TMP3, MM2, M)      '+MM2
            CC = BigIntMul(TMP, MM1, M)        'xMM1
            '
            CC = BIKetaN(CC, DigitL)
            'ߒlZbg
            BILnX = CC
        End If
    End If
    '
    If Not IsMissing(debug2_) Then Call BI_debug2(debug2_, 0.00001, OldTime)
    '
Exit Function
ERR:
'Resume Next
    'uG[`FbNvXLbvɖ߂
    ErrorCheckSkipFLG = False
    BigIntErrFLG = ERR.number
    Call BIWarnningDialog(Error(BigIntErrFLG) & vbCr & vbCr, "BILnX")
End Function
'******ixj**************************************
'Rΐ
Public Function BILnX2(A As BigIntType, Optional Digit As Variant, Optional N As Long = LogLimitN, _
                       Optional debug_ As Variant, Optional debug2_ As Variant, Optional debug3_ As Variant) As BigIntType
'  Log X  Rΐ e [Log e(X)=(-1)^k(1/(k+1))(X-1)^(k+1)]  ( 0<X<=2)
'------------------------------------------------------------------------------
'    A         [BigIntType]       Rΐ߂f[^
'        Digit     [Variant/Long]             iȗj߂錅         iȗ A ̌j
'        N         [Long]             iȗjőJԂvZ iȗ pubN萔 LogLimitNj
'        debug_    [Variant/Object]   iȗj[U[tH[̃IuWFNg  vZߒ̏o͐
'        debug2_   [Variant/Object]   iȗj[U[tH[̃IuWFNg  vZԂ̏o͐
'  ߒl  I  [BigIntType]       Rΐ
'@@  @ُI  [BigIntType]       [U[`^̃G[l (BigSgn:""(ASCIIR[hԍ0), BigInt:"", BigExp:0, BigDat:Empty)
'------------------------------------------------------------------------------
'    RΐWJ [Log e(X)=(-1)^k(1/(k+1))(X-1)^(k+1)] 苁߂܂
'------------------------------------------------------------------------------
'    0 < X <= 2
'        ȗ̌vZ:LogLimitN=1000000
'------------------------------------------------------------------------------
'  ˑ  ֐  BICBit, BigIntAdd, BigIntSub, BigIntMul, BigIntDiv,
'              BIIsError, BIIsAEqualB, BIIsBOrMore, Bigint2String, BIKetaN,
'              BIWarnningDialog,
'              DigitCheck, SetBigIntDigitCalculations,
'              Wait
'        萔  BigIntLimit, DefaultDigit, LogLimitN
'        ϐ  DefaultDigit2, BigIntErrFLG,
'              NowTime, LastTime
'  ̃Xg͒ڗpĂ֐E萔Eϐ̂݁iVBAg݊֐E萔j
'------------------------------------------------------------------------------
'    x̂Œʏ́ABILnX gpĉ
'
'         Digit ͏ȗ\A߂錅ƂĕK{
'------------------------------------------------------------------------------
'  Ql@vZԁ@mF
'------------------------------------------------------------------------------
Dim AA       As BigIntType   'Copy
Dim CC       As BigIntType   '
Dim X0       As BigIntType   '萔  0
Dim X1       As BigIntType   '      1
Dim X2       As BigIntType   '      2
Dim d        As BigIntType   '(X-1)^n
Dim D0       As BigIntType   '(X-1)
Dim f        As BigIntType   '1/k
Dim TMP      As BigIntType   'vZ̉l
Dim TMP2     As BigIntType   '
Dim BLog0    As BigIntType   'Oil(X-1)j
Dim BLogN    As BigIntType   'm
Dim BLog1    As BigIntType   'Pȍ~݌v  ̐
Dim I        As Integer
Dim K        As Integer
Dim M        As Long         'vZ
Dim dE       As Long         'liOƌvŽj
Dim Ddm      As Long         ']Ti錅j[Decision-digit margin]
Dim Nnow     As Long         '݂̌vZߒo
Dim NlAst    As Long         'ǑvZߒo
Dim dDigit   As Long         ']T
Dim DigitL   As Long         '=Digit
Dim dStepN   As Long         'o͕px
Dim DigitD   As Double       '=Digit
Dim ddDigit  As Double       ']T dDigit ̊
'
Dim OldTime As Single
Dim DebugTxt As String
    On Error GoTo ERR:
    '
    If Not IsMissing(debug2_) Then Call BI_debug2(debug2_, 0#, OldTime)
    '
    If BIIsError(A) Then
    '`FbN
        BigIntErrFLG = 5     'uvV[W̌ĂяoA܂͈słBv
        Error BigIntErrFLG
    ElseIf N <= 0 Then
    'őJԂvZ `FbN
        BigIntErrFLG = 5
        Error BigIntErrFLG
    Else
        '߂錅
        If Not DigitCheck(Digit) Then Exit Function
        '
        AA = A
        Call CutLastZero(AA)
        '
        DigitL = CLng(Digit)
        DigitD = CDbl(Digit)
        '萔
        X0 = BICBit(0)
        X1 = BICBit(1)
        X2 = BICBit(2)
        '
        Ddm = 1       ']T
        dStepN = 50   'o̓Xebv
        '===============================================
        '
        ddDigit = 0.005   ' 0.5%
        ']T
        dDigit = 5 + CLng(ddDigit * DigitD)
        'vZ
        M = SetBigIntDigitCalculations(DigitL, dDigit)
        '===============================================
        'Z\͈̓`FbN
        If (Not BIIsAEqualB(AA, X2)) And BIIsBOrMore(X2, AA) And BIIsBOrMore(AA, X0) And BIIsAEqualB(AA, X0) Then
            BigIntErrFLG = 5
            Error BigIntErrFLG
        Else
            '
            If Not IsMissing(debug_) Then DebugTxt = "---------------------------" & vbCr & _
                                                     " K : vZ" & vbCr & _
                                                     " N : ̋܂ (Pȍ~)" & vbCr & _
                                                     " L : vZiPȍ~j̗L" & vbCr & _
                                                     " T : vZ" & vbCr & _
                                                     "---------------------------" & vbCr
            If Not IsMissing(debug_) Then Call BI_debug1(debug_, DebugTxt, 0.00001)
            '
            BLog0 = BigIntSub(AA, X1, M)   'l(X-1)iOj
            BLog1 = X0                     'Pȍ~݌v  ݂̐
            d = BLog0    '(X-1)^n
            D0 = BLog0   '(X-1)
            '
            'ڍׂȉߒo
            If Not IsMissing(debug3_) Then Call BI_debug1(debug_, "K:0, " & Bigint2String(BLog0) & vbCr, 0.00001)
            '
            'uG[`FbNvXLbv
            ErrorCheckSkipFLG = True
            '[Log e(X)=(-1)^k(1/(k+1))(X-1)^(k+1)]
            For K = 1 To N
            'Pȍ~ vZ
                '---------------------------------------------------------------
                '(X-1)^(k+1)
                d = BigIntMul(d, D0, M)
                '1/(k+1)
                f = BigIntDiv(X1, BICBit(K + 1), M)
                '--------------------------------------------------------
                'jivZl^j
                BLogN = BigIntMul(d, f, M)
                ' [(-1)^k]
                If K Mod 2 = 1 Then
                    BLogN.BigSgn = "-"
                End If
                '------------------------------------------------------------
                'Z
                BLog1 = BigIntAdd(BLog1, BLogN, M)
                'l Zo
                dE = (Len(BLog0.BigInt) + BLog0.BigExp) - (Len(BLogN.BigInt) + BLogN.BigExp)
                '------------------------------------------------------------
                '
                'ڍׂȉߒo
                If Not IsMissing(debug3_) Then Call BI_debug1(debug_, "K:" & CStr(K) & ", " & Bigint2String(BLog1) & vbCr, 0.00001)
                '
                If K Mod dStepN = 0 Then
                    'WaitCPUƐ肵Ȃׂ̂̂Ȃ̂ō폜ȂI
                    Call Wait(0.0001)   'DoEvents
                    '
                    If Not IsMissing(debug_) Then
                        Nnow = dE
                        If Nnow > NlAst + 1 Then
                            DebugTxt = "K:" & CStr(K) & _
                                       ", N:" & Format(NlAst + 1, "00") & "`" & Format(Nnow, "00") & _
                                       ", L:" & Len(BLog1.BigInt) & _
                                       ", T:" & Format(NowTime - OldTime, "#0.000 Sec") & vbCr
                        Else
                            DebugTxt = "K:" & CStr(K) & _
                                       ", N:" & Format(Nnow, "00") & _
                                       ", L:" & Len(BLog1.BigInt) & _
                                       ", T:" & Format(NowTime - OldTime, "#0.000 Sec") & vbCr
                        End If
                        NlAst = Nnow
                    End If
                    If Not IsMissing(debug_) Then Call BI_debug1(debug_, DebugTxt, 0.00001)
                    If Not IsMissing(debug2_) Then Call BI_debug2(debug2_, 0.00001, OldTime)
                    '
                End If
                ' -----------------------------------------------------------
                If dE >= Digit + Ddm Then
                '
                    '
                    If Not IsMissing(debug_) Then
                        Nnow = dE
                        DebugTxt = "l 1E+" & CStr(Digit + Ddm) & "(*) ̂PȉƂȂ܂B" & vbCr & _
                                   "El(O) [" & BI2ExpN(BLog0, 8) & "]" & vbCr & _
                                   "E" & CStr(K) & " T[" & BI2ExpN(BLogN, 8) & "]" & vbCr & _
                                   "(*):߂錅{]T [=" & CStr(Digit) & "+" & CStr(Ddm) & "]" & vbCr & _
                                   "lƔfČvZI܂B" & vbCr & _
                                   "I" & vbCr & _
                                   "K:" & CStr(K) & _
                                   ", N:" & Format(Nnow, "00") & _
                                   ", L:" & Len(BLog1.BigInt) & _
                                   ", T:" & Format(NowTime - OldTime, "#0.000 Sec") & vbCr
                    End If
                    If Not IsMissing(debug_) Then Call BI_debug1(debug_, DebugTxt, 0.00001)
                    If Not IsMissing(debug2_) Then Call BI_debug2(debug2_, 0.00001, OldTime)
                    '
                    Exit For
                End If
            Next K
            'uG[`FbNvXLbvɖ߂
            ErrorCheckSkipFLG = False
            '
            If K > N Then
            'őJԂvZ
                If Not IsMissing(debug_) Then
                    DebugTxt = "----------------------------------" & vbCr & _
                               "̓r BLog0+BLog1:" & Bigint2String(BigIntAdd(BLog0, BLog1, Digit)) & vbCr & _
                               "----------------------------------" & vbCr & _
                               "Pȍ~̍v BLog1:" & Bigint2String(BLog1) & vbCr & _
                               "----------------------------------" & vbCr & _
                               "O BLog0:" & Bigint2String(BLog0) & vbCr & _
                               "----------------------------------" & vbCr & _
                               "őJԂvZ񐔁ilj [N:" & CStr(N) & "] ɒB܂B" & vbCr & _
                               "JԂvZ͎ɏI܂B " & vbCr
                End If
                If Not IsMissing(debug_) Then Call BI_debug1(debug_, DebugTxt, 0.00001)
                If Not IsMissing(debug2_) Then Call BI_debug2(debug2_, 0.00001, OldTime)
            End If
            '
            '̌vZiO{Pȍ~̍vj
            CC = BigIntAdd(BLog0, BLog1, M)
            '
            CC = BIKetaN(CC, DigitL)
            'ߒlZbg
            BILnX2 = CC
        End If
    End If
    '
    If Not IsMissing(debug2_) Then Call BI_debug2(debug2_, 0.00001, OldTime)
    '
Exit Function
ERR:
'Resume Next
    'uG[`FbNvXLbvɖ߂
    ErrorCheckSkipFLG = False
    BigIntErrFLG = ERR.number
    Call BIWarnningDialog(Error(BigIntErrFLG) & vbCr & vbCr, "BILnX2")
End Function
