Attribute VB_Name = "BigInt_Functions_8"
Option Explicit
'
'------------------------------------------------------------------------------
'  VBAő{Zs߂̃Cup  Z֐W
'    WW[ BigInt_Definition_1`3 K{
'    WW[ BigInt_Functions_1 `7 K{
'    WW[ BigInt_Functions_FFT   K{
'------------------------------------------------------------------------------
'
'pubN萔
'------------------------------------------------------------------------------
'pubNϐ
'------------------------------------------------------------------------------
'vCx[g萔
'------------------------------------------------------------------------------
'vCx[gϐ
'------------------------------------------------------------------------------
'
'̃W[̊֐ꗗ
'------------------------------------------------------------------------------
' ======= Sub ֐ ===============================================
' ======= Function ֐ ==========================================
'    R̉  BIEq3D(K3 As BigIntType, K2 As BigIntType, K1 As BigIntType, K0 As BigIntType, K() As BigIntType, _
'                           Optional Digit As Variant, Optional RealFLG As Boolean = False) As Boolean
'    Q̉  BIEq2D(K2 As BigIntType, K1 As BigIntType, K0 As BigIntType, K() As BigIntType, _
'                           Optional Digit As Variant, Optional RealFLG As Boolean = False) As Boolean
'------------------------------------------------------------------------------
'
'ỹW[̍XVz
'       ɂ            o[W                                  XVe
' ---------------+----------------------------------+---------+-----------------------------------------------------------------------------------
'    [2010/05/30] Ver.1.90 Alpha EditioniJŁj      X  R̉  gpOp֐Binary Splitting@łɕύX
'    [2010/02/14] Ver.1.89 Alpha EditioniJŁj      X  REQ̉  ߒlɉXgǉ
'                                                     C      R̉  d̂s(T>0)Ɂ{ΓKpOP[XݒC
'                                                                               <`Ver1.80(J)܂ł͐AVer1.81ŏC~X`Ver.1.88܂>
'                                                     C      Q̉  d[D=0]̉̌vZC
'    [2009/12/07] Ver.1.87 Alpha EditioniJŁj  C      R̉  1/3捪ׂ悩痧ŋ߂悤ɕύX
'                                                     C      R̉  덷␳(X^3+A=0Ȃǂ̏ꍇ)AvZ(M+3)̃`FbNǉ
'                                                     C      REQ̉  ʎ̔Ɍ
'                                                     dlύX  REQ̉  (RealFLG)ǉ
'    [2009/11/10] Ver.1.86 Alpha EditioniJŁj      X  R̉AQ̉  ꕔ̔ʎ֐(BIEq0)ɕύX
'                                                         X  Q̉  ꕔsv폜
'                                                     dlύX  R̉AQ̉  Digitȗ̒l (DefaultDigit32)
'    [2008/06/30] Ver.1.61 Alpha EditioniJŁj  C      R̉AQ̉  G[኱
'    [2008/06/20] Ver.1.58 Alpha EditioniJŁj      X  W[(BigInt_Functions_8BigInt_Functions_A)
'    [2008/06/18] Ver.1.57 Alpha EditioniJŁj  VKǉ  Q̉
'                                                           R̉  R̍ȊÕ[
'    [2008/06/14] Ver.1.52 Alpha EditioniJŁj  VKǉ  R̉
'------------------------------------------------------------------------------
'  ӎ  ̃W[݂̂ł͍쓮ł܂
'             VBAő{Zs߂̃Cu(BigInt_Definition_1`2,BigInt_Functions_1`7)Kvł
'------------------------------------------------------------------------------
'

'R̉
Public Function BIEq3D(K3 As BigIntType, K2 As BigIntType, K1 As BigIntType, K0 As BigIntType, K() As BigIntType, _
                       Optional Digit As Variant, Optional RealFLG As Boolean = False) As Boolean
'  R̉
'------------------------------------------------------------------------------
'    K3        [BigIntType]  W R̍
'        K2        [BigIntType]  W Q̍
'        K1        [BigIntType]  W P̍
'        K0        [BigIntType]  W 萔
'        K         [BigIntType]  iߒlpjR̉ (z`)
'                                  K(x)
'                                     0: Digit ()
'                                     1: P̎
'                                     2: @Q́@V
'                                     3: @Ŕ@V
'                                     4: @P̋
'                                     5: @Q́@V
'                                     6: @Ŕ@V
'                                  *  7: P@xxx.xxx + yyy.yyy i `
'                                  *  8: Q@@V
'                                  *  9: R@@V
'                                  * 10: P`R xxx.xxx + yyy.yyyi `Xg
'                                  * : l [Variant] Ɋi[
'        Digit     [Long]        iȗj߂錅iȗDefaultDigitj
'        RealFLG   [Boolean]     iȗĵ݋߂iȗFalsej
'  ߒl  I  [Boolean]     True
'        ُI  [Boolean]     False
'------------------------------------------------------------------------------
'    R̉߂
'------------------------------------------------------------------------------
'    0 < Digit
'        ʎ<0 (R̈قȂ)A܂́A
'        ʎ=0 (Rd or Qd(Ƃ͈قȂ)P)̂ƂA
'          ~A
'            Digit <= 20001 ̂Ƃ́A\
'            Digit >  20001       ́AvZiZԂ܂j苁߂܂
'------------------------------------------------------------------------------
'  ˑ  ֐  BICBit, BigIntAdd, BigIntSub, BigIntMul, BigIntDiv, BIReciprocal,
'              BIIsError, BIIsAEqualB, BIIsBsmallerA,
'              BISqr, BIPi, BISin, BIAtn, Bigint2String, BIEq0
'        萔  BigIntLimit
'  ̃Xg͒ڗpĂ֐E萔Eϐ̂݁iVBAg݊֐E萔j
'  Qȉ̈ˑ֐ѐݒl
'        ֐  BISqrN2, BICub, BICubDV, BIDecimal2Binary, BISgn, BIAbs, BIMaxV,
'              BIKetaAwase, BIKetaN, BIOverflowErrCheck,
'              BICDbl, BIMod, BIInt, String2BigInt,
'              BILnX, BIE, BigIntClear, BIStringCheck
'              DigitCheck, SetBigIntDigitCalculations,
'        萔  BigExpLimit, DefaultDigit
'              BsqrLimitC,
'              TrigonoLimitN, InvtrigonoLimitN
'              LogLimitN
'        ϐ  DefaultDigit2, BPiC, BeC, FunctionChangeFLG
'  ̑Ƀ[U[`^f[^^Typeݒ BigIntType Kv
'------------------------------------------------------------------------------
'    ́A K ɔz`Ŋi[
'        ܂Axxx.xxx + yyy.yyy i `   l [Variant]Ɋi[
'
'         Digit ͏ȗ\A߂錅ƂĕK{
'------------------------------------------------------------------------------
'  Ql  vZ  (Pentium 4 3.20C GHz)
'          [By Ver.1.87 BigInt_Demo(vZߒo:ON)]
'         eW      500̂R̉     500܂ŋ߂       2b x (0.004  Sec/)
'                     1,000                     1,000܂ŋ߂       5b x (0.005  Sec/)
'                     2,000                     2,000܂ŋ߂       8b x (0.004  Sec/)
'                     5,000                     5,000܂ŋ߂      16b x (0.0032 Sec/)
'                    15,000                    15,000܂ŋ߂      35b x (0.0023 Sec/)
'                    50,000                    50,000܂ŋ߂   215b x (0.0027 Sec/)
'                   100,000                   100,000܂ŋ߂   500b x (0.003  Sec/)
'                   500,000                   500,000܂ŋ߂    v x (       Sec/)
'------------------------------------------------------------------------------
Dim A      As BigIntType   'X^3+AX^2+BX+C=0 W A
Dim B      As BigIntType   '                     B
Dim C      As BigIntType   '                     C
Dim d      As BigIntType   'ʎ
Dim P      As BigIntType   '
Dim q      As BigIntType   '
Dim D0     As BigIntType   'ʗp
Dim P0     As BigIntType   '
Dim Q0     As BigIntType   '
Dim T      As BigIntType
Dim U      As BigIntType
Dim V      As BigIntType
Dim KK()   As BigIntType   'i[p
Dim P2     As BigIntType
Dim SU     As BigIntType
Dim SV     As BigIntType
Dim ALP    As BigIntType
Dim TMP    As BigIntType   'vZp
Dim TMP1   As BigIntType   '
Dim TMP2   As BigIntType   '
Dim TMP3   As BigIntType   '
Dim TMP4   As BigIntType   '
Dim TMP5   As BigIntType   '
Dim TMP6   As BigIntType   '
Dim TMP7   As BigIntType   '
Dim TMP8   As BigIntType   '
Dim TMP9   As BigIntType   '
Dim BTPi   As BigIntType   '
Dim X0     As BigIntType   '萔 0
Dim X1     As BigIntType   '     1
Dim X2     As BigIntType   '     2
Dim X3     As BigIntType   '     3
Dim X4     As BigIntType   '     4
Dim X6     As BigIntType   '     4
Dim X9     As BigIntType   '     9
Dim X27    As BigIntType   '    27
Dim X02    As BigIntType   '   1/2
Dim X03    As BigIntType   '   1/3
Dim X06    As BigIntType   '   1/6
Dim x09    As BigIntType   '   1/9
Dim X027   As BigIntType   '   1/27
Dim X_1    As BigIntType   '    -1
Dim M      As Long         'vZ
Dim M3     As Long         'vZ+3 (<=BigIntLimit)
Dim dDigit As Long         ']T (>=5 xƂ, 傫قǌvZ덷͏Ȃ邪ZԂ傷)
'֐iQj3X^2+2AX+B=0
Dim A2     As BigIntType   'X^2 W   : A2=3
Dim B2     As BigIntType   '  X W   : B2=2A
Dim C2     As BigIntType   '    萔 : C2=B
Dim KK2()  As BigIntType   'i[p
    On Error GoTo ERR:
    BigIntErrFLG = False
    If BIIsError(K3) Or BIIsError(K2) Or BIIsError(K1) Or BIIsError(K0) Then
    '`FbN
        BigIntErrFLG = 5     'uvV[W̌ĂяoA܂͈słBv
        Error BigIntErrFLG
    Else
        '߂錅
        If Not DigitCheck(Digit) Then Exit Function
        'R̍[`FbN
        If BIEq0(K3) Then
        'K3=0
            BigIntErrFLG = 5
            Error BigIntErrFLG
        Else
            ReDim KK(0 To 10)
            dDigit = 5           ']T
            'vZ
            M = SetBigIntDigitCalculations(Digit, dDigit)
            '
            '萔
            X0 = BICBit(0)
            X1 = BICBit(1)
            X2 = BICBit(2)
            X3 = BICBit(3)
            X4 = BICBit(4)
            X6 = BICBit(6)
            X9 = BICBit(9)
            X27 = BICBit(27)
            X_1 = BICBit(-1)
            X02 = BICBit(0.5)
            X03 = BIReciprocal(X3, M)
            X06 = BIReciprocal(X6, M)
            x09 = BIReciprocal(X9, M)
            X027 = BIReciprocal(X27, M)
            '͒l@lɊi[
            KK(0).BigDat = Digit
            'M3=M+3
            If BigIntLimit - M <= 3 Then
                M3 = BigIntLimit
            Else
                M3 = M + 3
            End If
            '1/K3iR̍+1Ɂj
            TMP = BIReciprocal(K3, M3)
            'X^3+AX^2+BX+C=0
            A = BigIntMul(K2, TMP, M3)  'K2*(1/K3)
            B = BigIntMul(K1, TMP, M3)  'K1*(1/K3)
            C = BigIntMul(K0, TMP, M3)  'K0*(1/K3)
            'R̍ȊÕ[`FbN
            If BIEq0(C) And (BIEq0(A) Or BIEq0(B)) Then
                If BIEq0(A) And BIEq0(B) Then
                '(A=0,B=0,C=0) X^3=0 [0,0,0]
                    KK(1) = X0: KK(2) = X0: KK(3) = X0   '
                    KK(4) = X0: KK(5) = X0: KK(6) = X0   '
                ElseIf BIEq0(A) Then
                '(A=0,C=0) X^3+BX=0X(X^2+B)=0
                    TMP = BIAbs(B)                 'Abs(B)
                    TMP1 = BISqr(TMP, M, , True)  'Abs(B)
                    KK(1) = X0: KK(4) = X0         'P
                    If Asc(B.BigSgn) = 43 Then
                    'B>0(A=0ȂB<>0B=0łȂ) L (X^2=B, B<0) [0,0+(B)i,0-(B)i]
                        If Not RealFLG Then
                            KK(2) = X0: KK(5) = TMP1   'Q
                            KK(3) = X0: KK(6) = TMP1   'R
                            KK(6).BigSgn = "-"
                        Else
                            KK(2).BigDat = "Complex": KK(5).BigDat = "Complex"   'Q
                            KK(3).BigDat = "Complex": KK(6).BigDat = "Complex"   'R
                        End If
                    Else
                    'B<0  (X^2=B, B>0) [0,+B,-B]
                        KK(2) = TMP1: KK(5) = X0   'Q
                        KK(3) = TMP1: KK(6) = X0   'R
                        KK(3).BigSgn = "-"
                    End If
                ElseIf BIEq0(B) Then
                '(B=0,C=0) X^3+AX^2=0X^2(X+A)=0 [0,0,-A]
                    KK(1) = X0: KK(4) = X0         'P
                    KK(2) = X0: KK(5) = X0         'Q
                    KK(3) = A:  KK(6) = X0         'R
                    If A.BigSgn = "+" Then
                        KK(3).BigSgn = "-"
                    Else
                        KK(3).BigSgn = "+"
                    End If
                Else
                'zOG[
                    Error 51
                    Exit Function
                End If
                ' + 
                KK(7).BigDat = Bigint2String(KK(1)) & " " & Bigint2String(KK(4)) & " i"  'P
                If KK(2).BigDat = "" Then KK(8).BigDat = Bigint2String(KK(2)) & " " & Bigint2String(KK(5)) & " i"  'Q
                If KK(3).BigDat = "" Then KK(9).BigDat = Bigint2String(KK(3)) & " " & Bigint2String(KK(6)) & " i"  'R
            Else
                '----------------------------------------------------
                ''''m[}
                ''''P = (3 * B - A * A) / 9
                '''TMP1 = BigIntMul(X3, B, M)        '3*B
                '''TMP2 = BigIntMul(A, A, M)         'A*A
                '''TMP3 = BigIntSub(TMP1, TMP2, M)   '(3*B-A*A)
                '''p = BigIntMul(TMP3, x09, M)
                '''
                ''''Q = (27 * C - 9 * A * B + 2 * A * A * A) / 27
                '''TMP1 = BigIntMul(X27, C, M)      '27*C
                '''TMP2 = BigIntMul(X9, X_1, M)     '-9*A*B
                '''TMP3 = BigIntMul(TMP2, A, M)     '
                '''TMP4 = BigIntMul(TMP3, B, M)
                '''TMP5 = BigIntMul(X2, A, M)       '2*A*A*A
                '''TMP6 = BigIntMul(TMP5, A, M)
                '''TMP7 = BigIntMul(TMP6, A, M)
                '''TMP8 = BigIntAdd(TMP1, TMP4, M)  '(27*C-9*A*B+2*A*A*A)
                '''TMP9 = BigIntAdd(TMP8, TMP7, M)
                '''Q = BigIntMul(TMP9, X027, M)
                '''
                ''''D = Q * Q + 4 * P * P * P
                '''TMP1 = BigIntMul(Q, Q, M)        'Q*Q
                '''TMP2 = BigIntMul(X4, p, M)       '4*P*P*P
                '''TMP3 = BigIntMul(TMP2, p, M)
                '''TMP4 = BigIntMul(TMP3, p, M)
                '''D = BigIntAdd(TMP1, TMP4, M)
                '----------------------------------------------------
                '
                'Łiʎ珜Zj
                'P0,Q0 ́Ao邾mȒl߂ׂɁAtZoi߂錅ݒ肵Ȃj
                '
                'P0 = (3 * B - A * A)
                'P  = (3 * B - A * A)/9
                TMP1 = BigIntMul(X3, B)                  '3*B
                TMP2 = BigIntMul(A, A)                   'A*A
                P0 = BigIntSub(TMP1, TMP2)               '(3*B-A*A)
                P = BigIntMul(P0, x09, M)                '(3*B-A*A)/9
                '
                'Q0 = (27 * C - 9 * A * B + 2 * A * A * A)
                'Q  = (27 * C - 9 * A * B + 2 * A * A * A)/27
                TMP1 = BigIntMul(X27, C)                 '27*C
                TMP2 = BigIntMul(X9, X_1)                '-9*A*B
                TMP3 = BigIntMul(TMP2, A)                '
                TMP4 = BigIntMul(TMP3, B)
                TMP5 = BigIntMul(X2, A)                  '2*A*A*A
                TMP6 = BigIntMul(TMP5, A)
                TMP7 = BigIntMul(TMP6, A)
                TMP8 = BigIntAdd(TMP1, TMP4)             '(27*C-9*A*B+2*A*A*A)
                Q0 = BigIntAdd(TMP8, TMP7)
                q = BigIntMul(Q0, X027, M)               '(27*C-9*A*B+2*A*A*A)/27
                '
                'D0 = (Q * Q + 4 * P * P * P)
                'D = (Q * Q + 4 * P * P * P)/(9^3)
                TMP1 = BigIntMul(Q0, Q0, M)              'Q*Q
                TMP2 = BigIntMul(X4, P0, M)              '4*P*P*P
                TMP3 = BigIntMul(TMP2, P0, M)
                TMP4 = BigIntMul(TMP3, P0, M)
                D0 = BigIntAdd(TMP1, TMP4, M)            'D0 = (Q*Q+4*P*P*P)
                TMP5 = BigIntMul(X9, X9, M)              '9^3
                TMP6 = BigIntMul(TMP5, X9, M)            '
                TMP7 = BIReciprocal(TMP6, M)             '1/(9^3)
                d = BigIntMul(D0, TMP7, M)               'D=(Q*Q+4*P*P*P)/(9^3)
                '----------------------------------------------------
                If Asc(D0.BigSgn) = 43 And (Not BIEq0(D0)) Then   'D0>0 (D0>=0 & D0<>0)
                '1 ̎ƂQ݂̌ɋȕf
                    'SU = (-Q + Sqr(D)) / 2
                    TMP1 = BigIntMul(q, X_1, M)                 '-Q
                    TMP2 = BISqr(d, M, , True)                  'Sqr(D)
                    TMP3 = BigIntAdd(TMP1, TMP2, M)
                    SU = BigIntMul(TMP3, X02, M)
                    '
                    If Asc(SU.BigSgn) = 43 Then                 'SU>=0
                        'U = SU ^ (1 / 3)
                        U = BICub(SU, M, , True)
                    Else
                        'U = (-SU) ^ (1 / 3) * (-1)
                        TMP1 = BigIntMul(SU, X_1, M)            '-SU
                        TMP2 = BICub(TMP1, M, , True)           '(-SU) ^ (1 / 3)
                        U = BigIntMul(TMP2, X_1, M)
                    End If
                    '
                    'SV = (-Q - Sqr(D)) / 2
                    If BIEq0(P0) And Asc(Q0.BigSgn) = 45 Then   '(P0=0)&(Q<0)
                        '덷␳ [X^3+A=0 Ȃǂ̏ꍇ:p=0ȂV=0]
                        SV = X0
                        V = X0
                    Else
                        TMP1 = BigIntMul(q, X_1, M)             '-Q
                        TMP2 = BISqr(d, M, , True)              'Sqr(D)
                        TMP3 = BigIntSub(TMP1, TMP2, M)         '(-Q - Sqr(D))
                        SV = BigIntMul(TMP3, X02, M)
                        '
                        If Asc(SV.BigSgn) = 43 Then             'SV>=0
                            'V = SV ^ (1 / 3)
                            V = BICub(SV, M, , True)
                        Else
                            'V = (-SV) ^ (1 / 3) * (-1)
                            TMP1 = BigIntMul(SV, X_1, M)        '-SV
                            TMP2 = BICub(TMP1, M, , True)       '(-SV) ^ (1 / 3)
                            V = BigIntMul(TMP2, X_1, M)
                        End If
                    End If
                    '
                    'ALP = U + V
                    ALP = BigIntAdd(U, V, M)
                    '
                    TMP1 = BigIntMul(A, X03, M)                 'A*(1/3)
                    If Not RealFLG Then
                        TMP2 = BigIntMul(BigIntMul(ALP, X02, M), X_1, M)  '-(ALP / 2)
                        TMP3 = BigIntSub(U, V, M)               '(U - V)
                        TMP4 = BISqr(X3, M, , True)             'Sqr(3)
                    End If
                    '
                    '
                    KK(1) = BigIntSub(ALP, TMP1, Digit)         'ALP - A / 3         'P
                    If Not RealFLG Then
                        KK(2) = BigIntSub(TMP2, TMP1, Digit)    '-(ALP / 2) - A / 3  'Q
                        KK(3) = BigIntSub(TMP2, TMP1, Digit)    '-(ALP / 2) - A / 3  'R
                    Else
                        KK(2).BigDat = "Complex"                'Q
                        KK(3).BigDat = "Complex"                'R
                    End If
                    '
                    KK(4) = X0                                                      '0                       'P
                    If Not RealFLG Then
                        KK(5) = BigIntMul(BigIntMul(TMP4, X02, M), TMP3, Digit)     'Sqr(3) / 2 * (U - V)    'Q
                        KK(6) = BigIntMul(BigIntMul(BigIntMul(TMP4, X_1, M), X02, M), TMP3, Digit)
                                                                                    '-(Sqr(3)) / 2 * (U - V) 'R
                    Else
                        KK(5).BigDat = "Complex"               'Q
                        KK(6).BigDat = "Complex"               'R
                    End If
                    ' + 
                    'KK(7) = KK(1) & " + " & KK(4) & " i"  'P
                    'KK(8) = KK(2) & " + " & KK(5) & " i"  'Q
                    'KK(9) = KK(3) & " + " & KK(6) & " i"  'R
                    KK(7).BigDat = Bigint2String(KK(1)) & " " & Bigint2String(KK(4)) & " i"  'P
                    If KK(2).BigDat = "" Then KK(8).BigDat = Bigint2String(KK(2)) & " " & Bigint2String(KK(5)) & " i"  'Q
                    If KK(3).BigDat = "" Then KK(9).BigDat = Bigint2String(KK(3)) & " " & Bigint2String(KK(6)) & " i"  'R
                Else
                '(<0:R̈قȂ) ܂ (=0:Rd or Qd(Ƃ͈قȂ)P)
                    '
                    BTPi = BIPi(M, True, 0)
                    '
                    If Asc(D0.BigSgn) = 45 Then
                    'D<0
                    'R̈قȂ
                        If BIEq0(Q0) Then
                            T = BigIntMul(BIPi, X02, M)      '/2
                        Else
                        'Q<>0
                            'T = Atn(Sqr(-D) / (-Q))
                            TMP1 = BigIntMul(d, X_1, M)      '-D
                            TMP2 = BISqr(TMP1, M, , True)    'Sqr(-D)
                            TMP3 = BigIntMul(q, X_1, M)      '-Q
                            TMP4 = BIReciprocal(TMP3, M)     '1/-Q
                            TMP5 = BigIntMul(TMP2, TMP4, M)  'Sqr(-D)/(-Q)
                            T = BIAtnBS(TMP5, M)             '
                            If Asc(T.BigSgn) = 45 Then       'T=T+  T<0
                                T = BigIntAdd(T, BTPi, M)
                            End If
                        End If
                    Else
                    'D=0
                        If BIEq0(P0) Then
                            If BIEq0(Q0) Then
                            'Rd
                                T = BigIntMul(BIPi, X02, M)      '/2
                            Else
                            'Q<>0
                            'zOG[
                                Error 51
                                Exit Function
                            End If
                        Else
                        'P<>0
                            If Not BIEq0(Q0) Then
                            'Qd(Ƃ͈قȂ)P
                                'R           F(x) =X^3+AX^2+BX+C
                                '֐iQj F'(x)=3X^2+2AX+B
                                If Asc(Q0.BigSgn) = 43 Then   '>0 (=0͂蓾Ȃ̂ōlȂ)
                                    'Ee(x)́AQd(Ƃ͈قȂ)P̊Ԃ̂x{
                                    '            x{
                                    '             /
                                    '          /  
                                    '    -----/--------- -> X
                                    '        /    Qd
                                    'EQd́AF'(x)=0̉̑傫
                                    T = BTPi                  'T=
                                Else
                                'Q<0
                                    'Ee(x)́AQd(Ƃ͈قȂ)P̊Ԃ̂x|
                                    '    Qd    /
                                    '    -----------/--- -> X
                                    '            /
                                    '         /  
                                    '        /  x|
                                    'EQd́AF'(x)=0̉̏
                                    T = X0                    'T=0
                                End If
                            Else
                            'Q=0
                            'zOG[
                                Error 51
                                Exit Function
                            End If
                        End If
                    End If
                    '
                    'P2 = Sqr(-P) * 2
                    TMP1 = BigIntMul(P, X_1, M)          '-P
                    TMP2 = BISqr(TMP1, M, , True)        'Sqr(-P)
                    P2 = BigIntMul(TMP2, X2, M)
                    '
                    TMP1 = BigIntMul(A, X03, M)          'A*(1/3)
                    TMP2 = BigIntMul(T, X03, M)          'T*(1/3)
                    TMP3 = BigIntMul(BTPi, X02, M)       '*(1/2)
                    TMP4 = BigIntMul(BTPi, X06, M)       '*(1/6)
                    '
                    '
                    'KK(1) = -P2 * Sin(Application.Pi() / 6 + T / 3) - A / 3  'P
                    TMP5 = BigIntAdd(TMP4, TMP2, M)      'Application.Pi() / 6 + T / 3
                    TMP6 = BISinBS(TMP5, M, 2)           'Sin(Application.Pi() / 6 + T / 3)
                    TMP7 = BigIntMul(P2, X_1, M)         '-P2
                    TMP8 = BigIntMul(TMP7, TMP6, M)      '-P2 * Sin(Application.Pi() / 6 + T / 3)
                    KK(1) = BigIntSub(TMP8, TMP1, Digit)
                    'KK(2) = -P2 * Sin(Application.Pi() / 6 - T / 3) - A / 3  'Q
                    TMP5 = BigIntSub(TMP4, TMP2, M)      'Application.Pi() / 6 - T / 3
                    TMP6 = BISinBS(TMP5, M, 2)            'Sin(Application.Pi() / 6 - T / 3)
                    TMP7 = BigIntMul(P2, X_1, M)         '-P2
                    TMP8 = BigIntMul(TMP7, TMP6, M)      '-P2 * Sin(Application.Pi() / 6 - T / 3)
                    KK(2) = BigIntSub(TMP8, TMP1, Digit)
                    'KK(3) = P2 * Sin(Application.Pi() / 2 - T / 3) - A / 3   'R
                    TMP5 = BigIntSub(TMP3, TMP2, M)      'Application.Pi() / 2 - T / 3
                    TMP6 = BISinBS(TMP5, M, 2)           'Sin(Application.Pi() / 2 - T / 3)
                    TMP7 = BigIntMul(P2, TMP6, M)        'P2 * Sin(Application.Pi() / 2 - T / 3)
                    KK(3) = BigIntSub(TMP7, TMP1, Digit)
                    '
                    KK(4) = X0   '0  'P
                    KK(5) = X0   '0  'Q
                    KK(6) = X0   '0  'R
                    '
                    ' + 
                    'KK(7) = KK(1) & " + " & KK(4) & " i"  'P
                    'KK(8) = KK(2) & " + " & KK(5) & " i"  'Q
                    'KK(9) = KK(3) & " + " & KK(6) & " i"  'R
                    KK(7).BigDat = Bigint2String(KK(1)) & " " & Bigint2String(KK(4)) & " i"  'P
                    KK(8).BigDat = Bigint2String(KK(2)) & " " & Bigint2String(KK(5)) & " i"  'Q
                    KK(9).BigDat = Bigint2String(KK(3)) & " " & Bigint2String(KK(6)) & " i"  'R
                End If
            End If
            '{̏
            If Left$(KK(7).BigDat, 1) = "+" Then KK(7).BigDat = Mid$(KK(7).BigDat, 2)
            If Left$(KK(8).BigDat, 1) = "+" Then KK(8).BigDat = Mid$(KK(8).BigDat, 2)
            If Left$(KK(9).BigDat, 1) = "+" Then KK(9).BigDat = Mid$(KK(9).BigDat, 2)
            'P`R xxx.xxx + yyy.yyyi `Xg
            KK(10).BigDat = "" & KK(7).BigDat & Chr$(10) & _
                            "" & KK(8).BigDat & Chr$(10) & _
                            "" & KK(9).BigDat
            '-------------------------------------------------------------------
            'ߒlZbg
            Erase K
            K = KK
            BIEq3D = True
        End If
    End If
Exit Function
ERR:
'Resume Next
    BigIntErrFLG = ERR.number
    Call BIWarnningDialog(Error(BigIntErrFLG) & vbCr & vbCr, "BIEq3D")
End Function
'Q̉
Public Function BIEq2D(K2 As BigIntType, K1 As BigIntType, K0 As BigIntType, K() As BigIntType, _
                       Optional Digit As Variant, Optional RealFLG As Boolean = False) As Boolean
'  Q̉
'------------------------------------------------------------------------------
'    K2        [BigIntType]  W Q̍
'        K1        [BigIntType]  W P̍
'        K0        [BigIntType]  W 萔
'        K         [BigIntType]  Q̉ (z`)
'                                   K(x)
'                                    0: Digit ()
'                                    1: P̎
'                                    2: @Q́@V
'                                    3: @P̋
'                                    4: @Q́@V
'                                  * 5: P@xxx.xxx + yyy.yyy i `
'                                  * 6: Q@@V
'                                  * 7: P`Q xxx.xxx + yyy.yyyi `Xg
'                                  *: l [Variant] Ɋi[
'        Digit     [Long]        iȗj߂錅iȗDefaultDigitj
'        RealFLG   [Boolean]     iȗĵ݋߂iȗFalsej
'  ߒl  I  [Boolean]     True
'        ُI  [Boolean]     False
'------------------------------------------------------------------------------
'    Q̉߂
'------------------------------------------------------------------------------
'    0 < Digit <= BigIntLimit
'------------------------------------------------------------------------------
'  ˑ  ֐  BICBit, BigIntAdd, BigIntSub, BigIntMul, BigIntDiv,
'              BIIsError, BIIsAEqualB, BISqr, Bigint2String,
'              BIWarnningDialog, BIEq0
'              DigitCheck, SetBigIntDigitCalculations,
'        萔  BigIntLimit
'        ϐ  BigIntErrFLG
'  ̃Xg͒ڗpĂ֐E萔Eϐ̂݁iVBAg݊֐E萔j
'  Qȉ̈ˑ֐ѐݒl
'        ֐  BIKetaN
'        萔  BigExpLimit, DefaultDigit, BsqrLimitC
'        ϐ  DefaultDigit2, BigIntErrFLG,
'              NowTime, LastTime
'  ̑Ƀ[U[`^f[^^Typeݒ BigIntType Kv
'------------------------------------------------------------------------------
'    ́A K ɔz`Ŋi[
'
'         Digit ͏ȗ\A߂錅ƂĕK{
'------------------------------------------------------------------------------
'  Ql  vZ  (Pentium 4 3.20C GHz)
'          [By Ver.1.87 BigInt_Demo(vZߒo:ON)]
'         eW      500̂R̉     500܂ŋ߂       1b  (0.004  Sec/)
'                     1,000                     1,000܂ŋ߂       1b x (0.005  Sec/)
'                     2,000                     2,000܂ŋ߂       2b x (0.004  Sec/)
'                     5,000                     5,000܂ŋ߂       3b x (0.0032 Sec/)
'                    15,000                    15,000܂ŋ߂       7b x (0.0023 Sec/)
'                    50,000                    50,000܂ŋ߂      45b x (0.0027 Sec/)
'                   100,000                   100,000܂ŋ߂   120b x (0.003  Sec/)
'                   500,000                   500,000܂ŋ߂  1210b x (0.00146Sec/)
'------------------------------------------------------------------------------
Dim A      As BigIntType   'AX^2+BX+C=0 W A
Dim B      As BigIntType   '                B
Dim C      As BigIntType   '                C
Dim d      As BigIntType   'ʎ
Dim KK()   As BigIntType   'i[p
Dim TMP    As BigIntType   'vZp
Dim TMP1   As BigIntType   '
Dim TMP2   As BigIntType   '
Dim TMP3   As BigIntType   '
Dim TMP4   As BigIntType   '
Dim TMP5   As BigIntType   '
Dim X0     As BigIntType   '萔 0
Dim X1     As BigIntType   '     1
Dim X4     As BigIntType   '     4
Dim X02    As BigIntType   '   1/2
Dim M      As Long         'vZ
Dim dDigit As Long         ']T (>=5 xƂ, 傫قǌvZ덷͏Ȃ邪ZԂ傷)
    On Error GoTo ERR:
    BigIntErrFLG = False
    If BIIsError(K2) Or BIIsError(K1) Or BIIsError(K0) Then
    '`FbN
        BigIntErrFLG = 5     'uvV[W̌ĂяoA܂͈słBvG[^Iɔ
        Error BigIntErrFLG
    Else
        '߂錅
        If Not DigitCheck(Digit) Then Exit Function
        '萔
        X0 = BICBit(0)
        'Q̍[`FbN
        If BIEq0(K2) Then
            BigIntErrFLG = 5
            Error BigIntErrFLG
        Else
            ReDim KK(0 To 7)
            dDigit = 5           ']T
            'vZ
            M = SetBigIntDigitCalculations(Digit, dDigit)
            '
            '萔
            X1 = BICBit(1)
            X4 = BICBit(4)
            X02 = BICBit(0.5)
            '͒l@lɊi[
            KK(0).BigDat = Digit
            'AX^2+BX+C=0
            A = K2   'Q̍
            B = K1   'P̍
            C = K0   '萔
            'Q̍{
            If A.BigSgn = "-" Then
                A.BigSgn = "+"
                '[]]
                Call BISgnChange(B)
                Call BISgnChange(C)
            End If
            'Q̍ȊÕ[`FbN
            If BIEq0(B) Or BIEq0(C) Then
            '(B=0 or C=0)
                If BIEq0(B) And BIEq0(C) Then
                '(B=0,C=0) X^2=0 [0,0]
                    KK(1) = X0: KK(2) = X0             '
                    KK(3) = X0: KK(4) = X0             '
                ElseIf BIEq0(B) Then
                '(B=0) X^2+C=0X^2=-C
                    TMP = BIAbs(C)                     'Abs(C)
                    TMP1 = BISqr(TMP, Digit, , False)  'Abs(C)
                    If Asc(C.BigSgn) = 43 Then
                    'C>0(B=0ȂC<>0C=0łȂ) L (X^2=-C, C>0) [0+(C)i,0-(C)i]
                        If Not RealFLG Then
                            KK(1) = X0: KK(3) = TMP1   'P
                            KK(2) = X0: KK(4) = TMP1   'Q
                            KK(4).BigSgn = "-"
                        Else
                            KK(1).BigDat = "Complex": KK(3).BigDat = "Complex"   'P
                            KK(2).BigDat = "Complex": KK(4).BigDat = "Complex"   'Q
                        End If
                    Else
                    'C<0  (X^2=-C, C<0) [+C,-C]
                        KK(1) = TMP1: KK(3) = X0       'Q
                        KK(2) = TMP1: KK(4) = X0       'R
                        KK(2).BigSgn = "-"
                    End If
                ElseIf BIEq0(C) Then
                '(C=0) X^2+BX=0X(X+B)=0 [0,-B]
                    KK(1) = X0: KK(3) = X0             'P
                    KK(2) = B:  KK(4) = X0             'Q
                    '[]]
                    Call BISgnChange(KK(2))
                End If
            Else
            'ʏ̉̌
                'AX^2+BX+C=0
                'X=(-B}(B^2-4AC))/(2A)
                'ʎ D
                '  o邾mȒl߂ׂɁAtZoi߂錅ݒ肵Ȃj
                TMP = BigIntMul(B, B)                  'B*B
                TMP1 = BigIntMul(X4, A)                '4*A
                TMP2 = BigIntMul(TMP1, C)              '(4*A)*C
                '
                TMP3 = B                               'B
                '[]]
                Call BISgnChange(TMP3)                 '-B
                '
                d = BigIntSub(TMP, TMP2)               '(B^2-4AC)
                '
                If BIEq0(d) Then
                'D=0 d [-B/(2A),-B/(2A)]
                    TMP = BigIntMul(TMP3, X02, M)      '-B*(1/2)
                    TMP2 = BigIntDiv(TMP, A, Digit)    '(-B*(1/2))/A
                    KK(1) = TMP2: KK(3) = X0           'P
                    KK(2) = TMP2: KK(4) = X0           'Q
                Else
                    TMP5 = BigIntDiv(X02, A, M)        '(1/2)/A=(1/2A)
                    If Asc(d.BigSgn) = 43 Then
                    'D>0(D=0łȂ) Q̈قȂ
                        TMP = BISqr(d, M, , True)                 'D
                        TMP1 = BigIntAdd(TMP3, TMP, M)            '-B+D
                        TMP2 = BigIntSub(TMP3, TMP, M)            '-B-D
                        TMP3 = BigIntMul(TMP1, TMP5, Digit)       '(-B+D)/(2A)
                        TMP4 = BigIntMul(TMP2, TMP5, Digit)       '(-B-D)/(2A)
                        KK(1) = TMP3: KK(3) = X0                  'P
                        KK(2) = TMP4: KK(4) = X0                  'Q
                    Else
                    'D<0 ͂ȋ
                        If Not RealFLG Then
                            TMP4 = BigIntMul(TMP3, TMP5, Digit)   '(-B)/(2A)
                            TMP = d                               'D
                            TMP.BigSgn = "+"                      'Abs(D)
                            TMP1 = BISqr(TMP, Digit, , True)      'Abs(D)
                            TMP2 = BigIntMul(TMP1, TMP5, Digit)   '(Abs(D))/(2A)
                            KK(1) = TMP4: KK(3) = TMP2            'P
                            KK(2) = TMP4: KK(4) = TMP2            'Q
                            KK(4).BigSgn = "-"
                        Else
                            KK(1).BigDat = "Complex": KK(3).BigDat = "Complex"   'P
                            KK(2).BigDat = "Complex": KK(4).BigDat = "Complex"   'Q
                        End If
                    End If
                End If
            End If
            '-------------------------------------------------------------------
            'xxx.xxx + yyy.yyy i `
            'P
            If KK(1).BigDat = "" Then
                KK(5).BigDat = Bigint2String(KK(1)) & " " & Bigint2String(KK(3)) & " i"
            Else
                KK(5).BigDat = KK(1).BigDat
            End If
            'Q
            If KK(2).BigDat = "" Then
                KK(6).BigDat = Bigint2String(KK(2)) & " " & Bigint2String(KK(4)) & " i"
            Else
                KK(6).BigDat = KK(2).BigDat
            End If
            '{̏
            If Left$(KK(5).BigDat, 1) = "+" Then KK(5).BigDat = Mid$(KK(5).BigDat, 2)
            If Left$(KK(6).BigDat, 1) = "+" Then KK(6).BigDat = Mid$(KK(6).BigDat, 2)
            'PAQ xxx.xxx + yyy.yyyi `Xg
            KK(7).BigDat = "" & KK(5).BigDat & Chr$(10) & _
                           "" & KK(6).BigDat
            '-------------------------------------------------------------------
            'ߒlZbg
            Erase K
            K = KK
            BIEq2D = True
        End If
    End If
Exit Function
ERR:
'Resume Next
    BigIntErrFLG = ERR.number
    Call BIWarnningDialog(Error(BigIntErrFLG) & vbCr & vbCr, "BIEq2D")
End Function
