Attribute VB_Name = "BigInt_Functions_B"
Option Explicit
'
'------------------------------------------------------------------------------
'  VBAő{Zs߂̃Cup  Z֐a
'    WW[ BigInt_Definition_1`3       K{
'    WW[ BigInt_Functions_1`3,5,6,7  K{
'    WW[ BigInt_Functions_FFT         K{
'------------------------------------------------------------------------------
'
'pubN萔
'------------------------------------------------------------------------------
'pubNϐ
'------------------------------------------------------------------------------
'vCx[g萔
'------------------------------------------------------------------------------
'vCx[gϐ
'------------------------------------------------------------------------------
'
'̃W[̊֐ꗗ
'------------------------------------------------------------------------------
' ======= Sub ֐ ===============================================
' ======= Function ֐ ==========================================
'    Zp􉽕  Function BIAGM(A As BigIntType, B As BigIntType, Optional Digit As Variant) As BigIntType
'------------------------------------------------------------------------------
'
'ỹW[̍XVz
'       ɂ            o[W                                  XVe
' ---------------+----------------------------------+---------+-----------------------------------------------------------------------------------
'    [2009/11/10] Ver.1.86 Alpha EditioniJŁj  VKǉ  Zp􉽕ρiArithmetic-geometric meanj
'------------------------------------------------------------------------------
'  ӎ  ̃W[݂̂ł͍쓮ł܂
'             VBAő{Zs߂̃CuKvł
'------------------------------------------------------------------------------
'

'Zp􉽕ρiArithmetic-geometric meanj
Public Function BIAGM(A As BigIntType, B As BigIntType, Optional Digit As Variant) As BigIntType
' Zp􉽕 [A.G.M.]
'---------------------------------------------------------------------------
'  @A         [BigIntType]    [U[`^
'  @@@B         [BigIntType]    [U[`^
'  @@@Digit     [Long]          ߂錅
'  ߒl@I  [BigIntType]    [U[`^ (AGM̉)
'@@  @ُI  [BigIntType]    [U[`^̃G[l (BigSgn:""(ASCIIR[hԍ0), BigInt:"", BigExp:0, BigDat:Empty)
'------------------------------------------------------------------------------
'    |arg(b/a)|<>΂ł镡fa,bɂ
'          arg:fʂɂΊp
'        a(1) = (a + b) / 2
'        b(1) = (ab)
'        a(N + 1) = (a(N) + b(N)) / 2
'        b(n+1)=(a(n)b(n))
'         (n>=1)
'        ƒ߂΁A{a(n)},{b(n)}͓lɎB
'        ̋Ɍa, b̎Zp􉽕ςƌĂԡ
'        AA􉽕b(n)͎̍̕Zpa(n)̑ɂ̂IԁB
'------------------------------------------------------------------------------
'    A,BƂ̎(f͑ΏۊO)
'------------------------------------------------------------------------------
'  ˑ  ֐  BigIntSub, BIKetaAwase, BIKetaN, BIOverflowErrCheck, BIIsError
'              BIIsAEqualB, BIWarnningDialog, BIEq0,
'              SetBigIntDigitCalculations
'        萔  BigIntLimit, DefaultDigit
'        ϐ  DefaultDigit2, BigIntErrFLG, FunctionChangeFLG
'  ̃Xg͒ڗpĂ֐E萔Eϐ̂݁iVBAg݊֐E萔j
'------------------------------------------------------------------------------
'  
'------------------------------------------------------------------------------
'  Ql@vZ  (Pentium 4 2.80C GHz)
'------------------------------------------------------------------------------
Dim AA     As BigIntType   'Copy
Dim BB     As BigIntType   '
Dim CC     As BigIntType   'vZ̉
Dim EE     As BigIntType   '
Dim X05    As BigIntType   '萔  0
Dim M      As Long         'vZi=Digit:߂錅j
Dim Count  As Long         'JE^[
Dim LimtC  As Long         'vZ
Dim dDigit As Long         ']T
Dim Position_AA As Long    'ŏ̐̈ AA
Dim Position_EE As Long    'ŏ̐̈ EE
    On Error GoTo ERR:
    BigIntErrFLG = False
    If BIIsError(A) Or BIIsError(B) Then
    '`FbN
        BigIntErrFLG = 5     'uvV[W̌ĂяoA܂͈słBv
        Error BigIntErrFLG
    Else
        If Asc(A.BigSgn) = 45 Or Asc(B.BigSgn) = 45 Then
        'A<0 or B<0
            BigIntErrFLG = 5
            Error BigIntErrFLG
        ElseIf BIEq0(A) Or BIEq0(B) Then
        'A=0 or B=0
            BigIntErrFLG = 5
            Error BigIntErrFLG
        Else
            AA = A
            BB = B
            '萔
            dDigit = 3                 ']T
            LimtC = 1000               'vZ
            X05 = BICBit(0.5)
            '
            'vZi߂錅`FbNj
            M = SetBigIntDigitCalculations(DigitCheck_And_SetBigIntDigitCalculations(Digit, Len(AA.BigInt), Len(BB.BigInt), "AGM"), dDigit)
            '
            Count = 0
            Do
                Count = Count + 1
                CC = BigIntMul(BigIntAdd(AA, BB, M), X05, M)          'Zp
                BB = BISqr(BigIntMul(AA, BB, M), M)                   '􉽕
                AA = CC
                EE = BigIntSub(AA, BB, M)                             '
                '`FbN
                Position_AA = Len(AA.BigInt) + AA.BigExp              'AÄ
                Position_EE = Len(EE.BigInt) + EE.BigExp              'EË
                If BIEq0(EE) Then Exit Do                             'EE=0 ([̃`FbN)
                If (Position_AA - Position_EE) > Digit Then Exit Do   'L̃`FbN (̃`FbN)
            Loop While Count < LimtC
            If Count >= LimtC Then
                BigIntErrFLG = 51
                Error BigIntErrFLG
            End If
            '
            CC = BIKetaN(AA, CLng(Digit))
            'ߒlZbg
            BIAGM = CC
        End If
    End If
Exit Function
ERR:
'Resume Next
    BigIntErrFLG = ERR.number
    Call BIWarnningDialog(Error(BigIntErrFLG) & vbCr & vbCr, "BIAGM")
End Function
