Attribute VB_Name = "BigInt_Functions_Clothoid"
Option Explicit
'
'------------------------------------------------------------------------------
'  VBAő{Zs߂̃Cup  Z֐Clothoid
'    WW[ BigInt_Definition_1`3   K{
'    WW[ BigInt_Definition_SWTAPI K{
'    WW[ BigInt_Functions_1`2    K{
'    WW[ BigInt_Functions_FFT     K{
'------------------------------------------------------------------------------
'
'pubN萔
'------------------------------------------------------------------------------
'pubNϐ
'------------------------------------------------------------------------------
'vCx[g萔
Private Const ClothoidLimitC As Long = 500    'N\Ch  ȗ̓vZ(For`Next)
'------------------------------------------------------------------------------
'vCx[gϐ
'------------------------------------------------------------------------------
'
'̃W[̊֐ꗗ
'------------------------------------------------------------------------------
' ======= Sub ֐ ===============================================
' ======= Function ֐ ==========================================
'    N\ChW  BIClothoid(BIClothoidXY() As BigIntType, L As BigIntType, A As BigIntType, Optional Digit As Variant, Optional N As Variant = ClothoidLimitC, _
'                               Optional Count As Variant) As Boolean
'------------------------------------------------------------------------------
'
'ỹW[̍XVz
'       ɂ            o[W                                  XVe
' ---------------+----------------------------------+---------+-----------------------------------------------------------------------------------
'    [2009/11/10] Ver.1.86 Alpha EditioniJŁj  dlύX  N\ChW  Digitȗ̒l (DefaultDigit32)
'                                                     Pp  N\ChW  Z̐Pp (pubN萔:ClothoidLimitN)
'                                                     Pp  N\ChW  vZ񐔂̐Pp
'    [2009/11/10] Ver.1.86 Alpha EditioniJŁj      X  N\ChW  ꕔ̔ʎ֐(BIEq0)ɕύX
'    [2008/10/05] Ver.1.67 Alpha EditioniJŁj  VKǉ  N\Ch(BIClothoid)
'------------------------------------------------------------------------------
'  ӎ  ̃W[݂̂ł͍쓮ł܂
'             VBAő{Zs߂̃Cu(BigInt_Definition_1`2,BigInt_Functions_1,2)Kvł
'------------------------------------------------------------------------------
'

'N\ChW
Public Function BIClothoid(BIClothoidXY() As BigIntType, L As BigIntType, A As BigIntType, Optional Digit As Variant, Optional N As Variant = ClothoidLimitC, _
                           Optional Count As Variant) As Boolean
'  N\ChW
'-------------------------------------------------------------------------------
'I H`Ŏgp͈͂̌vŹA{x(BigInt_Sample_Clothoid_Dbl)   @I
'I ͂邩ɌvZԂł@@@@@@@@@@@@@@@@@@@@@   I
'I BigIntł́A{xł̌vZxEȏ̋Ȑ(L>8[A=1])łgp I
'-------------------------------------------------------------------------------
'    BIClothoidXY() [BigIntType]       iߒlpjN\ChW [(0):X, (1):Y]
'        L              [BigIntType]        N\ChȐ L
'        A              [BigIntType]        p[^ A
'        Digit          [Long]             iȗj߂(L)
'        N              [Long]             iȗjőJԂvZ񐔁iȗ pubN萔 ClothoidLimitCj
'        Count          [Long]             iȗjJԂvZ񐔁iߒlpŌvZɂ͎gpȂj
'  ߒl  I       [Boolean]          True
'        ُI       [Boolean]          Flse
'------------------------------------------------------------------------------
'    N\ChȐ́AȐ L Ɣa R ႷȐ
'@@@    R~L = A^2@iA͒萔j
'@      Cӓ_ł̃N\ChȐ LAa RAăтƂ̊Ԃɂ́A
'@@@     = L/2R
'------------------------------------------------------------------------------
'    :ClothoidLimitN=500, vZ:ClothoidLimitC=500
'------------------------------------------------------------------------------
'  ˑ  ֐  BICBit, BigIntAdd, BigIntMul, BigIntDiv, BIReciprocal,
'              BISgnChange, BIIsError, BIIsAEqualB, BIKetaN,
'              BIWarnningDialog, BIEq0,
'              DigitCheck, SetBigIntDigitCalculations,
'              Wait
'        萔  BigIntLimit, DefaultDigit, ClothoidLimitC
'        ϐ  DefaultDigit2, BigIntErrFLG,
'              NowTime, LastTime
'  L̃Xg͒ڗpĂ֐E萔Eϐ̂
'------------------------------------------------------------------------------
'    L(Ȑ)ƉZԂ͔Ⴕ܂B܂AL傫قǋ߂(L)傫ݒ肷Kv܂B
'        ZɎgp郂W[́A@ (BigIntMulS)gp܂
'        WarnningDialogL
'------------------------------------------------------------------------------
'  Ql  vZ  (Pentium 4 2.80C GHz) [By Ver.1.67 BigInt_Demo(vZߒo:ON)]
'                      A=1, L=1,    ߂(L) 64   1 b 
'                      A=1, L=2,    ߂(L) 64   1 b x
'                      A=1, L=12.5, ߂(L) 64  20 b x
'        vZE
'          Ep[^ A=1
'              EE_̔ʂ́AAutoCADŃ|C}̖ڎ`FbN
'              E0,0|()/2,()/2 [A=1̃N\ChS] ̐(y=x)Ƃĉ]JEg
'                  ߂(L)   4  L= 4.9 x܂ (Q])
'                                     8  L= 6.4 x܂ (R])
'                                    16  L= 8.9 x܂ (U])
'                                    32  L=12.0 x܂ (PP])
'                                    64  L=17.0 x܂ (QR])
'          ߂(L)4 ͎dlAڎ`FbNłʉ\Ȍ邪E_̔ʂł͖
'------------------------------------------------------------------------------
Dim BIClothoidX As BigIntType   'Wl X
Dim BIClothoidY As BigIntType   '       Y
Dim X0          As BigIntType   '萔 0
Dim X1          As BigIntType   '     1
Dim X2          As BigIntType   '     2
Dim R           As BigIntType   'a
Dim Tau         As BigIntType   '
Dim Tau2        As BigIntType   '^2
Dim F2N1X       As BigIntType   '(2(N-1))!
Dim F2N1Y       As BigIntType   '(2N-1)!
Dim TMP         As BigIntType   '
Dim TMP2        As BigIntType   '
Dim TMP3        As BigIntType   '
Dim TMP4        As BigIntType   '
Dim TMP5        As BigIntType   '
Dim SgnX        As BigIntType   'X
Dim CxTMP       As BigIntType   '
Dim CxTMP2      As BigIntType   '
Dim TauPowerX   As BigIntType   '
Dim FactorialX  As BigIntType   '
Dim SgnY        As BigIntType   'Y
Dim CyTMP       As BigIntType   '
Dim CyTMP2      As BigIntType   '
Dim TauPowerY   As BigIntType   '
Dim FactorialY  As BigIntType   '
Dim I           As Long         '
Dim K           As Long         '
Dim M           As Long         'vZ
Dim Ddm         As Long         ']Ti錅j[Decision-digit margin]
Dim dEX         As Long         'X livŽj
Dim dEY         As Long         'Y livŽj
Dim dDigit      As Long         'vZ]T
Dim dStepN      As Long         'o͕px
    On Error GoTo ERR:
    'Zo, őJԂvZ l`FbN
    If N <= 0 Then
        BigIntErrFLG = 5     'uvV[W̌ĂяoA܂͈słBv
        Error BigIntErrFLG
    Else
        '߂錅
        If Not DigitCheck(Digit) Then Exit Function
        '萔
        X0 = BICBit(0)
        X1 = BICBit(1)
        X2 = BICBit(2)
        '
        If BIIsError(L) Or BIIsError(A) Or Asc(A.BigSgn) = 45 Then
            BigIntErrFLG = 5
            Error BigIntErrFLG
        Else
        'L>=0
            CxTMP = X0
            CxTMP2 = X0
            BIClothoidX = X0
            CyTMP = X0
            CyTMP2 = X0
            BIClothoidY = X0
            '
            If BIEq0(L) Then
            'L=0
                BIClothoidX = X0
                BIClothoidY = X0
                'W ߒlZbg
                ReDim BIClothoidXY(0 To 1)
                BIClothoidXY(0) = BIClothoidX
                BIClothoidXY(1) = BIClothoidY
            Else
            'L>0 (L>=0 & L<>0)
                Ddm = 2       ']T
                dDigit = 3    'vZ]T
                dStepN = 2    'o̓Xebv
                'vZ
                M = SetBigIntDigitCalculations(Digit, dDigit)
                '
                'R = A * A / L
                TMP = BigIntMulS(A, A, M)
                TMP2 = BIReciprocal(L, M)
                R = BigIntMulS(TMP, TMP2, M)
                'Tau = L / (2 * R)
                TMP = BigIntMulS(R, X2, M)
                TMP2 = BIReciprocal(TMP, M)
                Tau = BigIntMulS(L, TMP2, M)
                'Tau^2
                Tau2 = BigIntMulS(Tau, Tau, M)
                '
                SgnX = X1
                SgnX.BigSgn = "-"
                SgnY = SgnX
                F2N1X = X1
                F2N1Y = X1
                '
                ' N ̈ʎ
                'X: A(2){(-1)^(N-1)/((2(N-1)!*(4N-3))*^(2*(N-1))}
                'Y: Aс(2){(-1)^(N-1)/((2N-1)!*(4N-1))*^(2*(N-1))}
                For I = 1 To N
                    Count = I
                    'CxTMP = ((-1) ^ (I - 1)) / ((2 * (I - 1)!) * (4 * I - 3)) * (Tau ^ (2 * (I - 1)))
                    'CyTMP = ((-1) ^ (I - 1)) / (((2 * I - 1)!) * (4 * I - 1)) * (Tau ^ (2 * (I - 1)))
                    '(-1)^(N-1)
                                                                         
                    '[]]
                    Call BISgnChange(SgnX)
                    SgnY = SgnX
                    'X:1/((2(N-1)!*(4N-3))
                    'Y:1/((2N-1)!*(4N-1))
                    If I = 1 Then
                        F2N1X = X1
                        F2N1Y = X1
                    Else
                        'X
                        TMP = BICBit(2 * (I - 1))
                        TMP2 = BICBit(2 * (I - 1) - 1)
                        TMP3 = BigIntMulS(TMP, TMP2, M)
                        TMP4 = BigIntMulS(F2N1X, TMP3, M)
                        F2N1X = TMP4
                        'Y
                        TMP = BICBit(2 * I - 1)
                        TMP2 = BICBit(2 * I - 1 - 1)
                        TMP3 = BigIntMulS(TMP, TMP2, M)
                        TMP4 = BigIntMulS(F2N1Y, TMP3, M)
                        F2N1Y = TMP4
                    End If
                    'X
                    TMP = BIReciprocal(F2N1X, M)
                    TMP2 = BICBit(4 * I - 3)
                    TMP3 = BIReciprocal(TMP2, M)
                    FactorialX = BigIntMulS(TMP, TMP3, M)
                    'Y
                    TMP = BIReciprocal(F2N1Y, M)
                    TMP2 = BICBit(4 * I - 1)
                    TMP3 = BIReciprocal(TMP2, M)
                    FactorialY = BigIntMulS(TMP, TMP3, M)
                    '^(2*(N-1))
                    If I = 1 Then
                        TauPowerX = X1
                        TauPowerY = X1
                    Else
                        TMP = BigIntMulS(TauPowerX, Tau2, M)
                        TauPowerX = TMP
                        TauPowerY = TauPowerX
                    End If
                    'CxTMP = SgnX * FactorialX * TauPowerX
                    CxTMP = BigIntMulS(FactorialX, TauPowerX, M)
                    CxTMP.BigSgn = SgnX.BigSgn
                    'CyTMP = SgnY * FactorialY * TauPowerY
                    CyTMP = BigIntMulS(FactorialY, TauPowerY, M)
                    CyTMP.BigSgn = SgnY.BigSgn
                    '
                    'l Zo
                    dEX = (Len(BIClothoidX.BigInt) + BIClothoidX.BigExp) - (Len(CxTMP.BigInt) + CxTMP.BigExp)
                    dEY = (Len(BIClothoidY.BigInt) + BIClothoidY.BigExp) - (Len(CyTMP.BigInt) + CyTMP.BigExp)
                    '-----------------------------------------------------------
                    '
                    If dEX > Digit + Ddm And dEY > Digit + Ddm Then
                    '
                        Exit For
                    ElseIf BIIsAEqualB(CxTMP, CxTMP2) And BIIsAEqualB(CyTMP, CyTMP2) Then
                    'ω
                        Beep
                        Exit For
                    ElseIf BIIsError(CxTMP) Or BIIsError(CyTMP) Then
                    'G[l
                        Beep
                        Beep
                        Exit Function
                    ElseIf K = N Then
                    'őJԂvZ
                        Beep
                        Beep
                        Beep
                        Exit For
                    End If
                    '-----------------------------------------------------------
                    TMP = BigIntAdd(BIClothoidX, CxTMP, M)
                    BIClothoidX = TMP
                    CxTMP2 = CxTMP
                    TMP = BigIntAdd(BIClothoidY, CyTMP, M)
                    BIClothoidY = TMP
                    CyTMP2 = CyTMP
                    '
                    If K Mod dStepN = 0 Then
                        Call Wait(0.0001)   'DoEvents
                    End If
                Next I
                'BIClothoidX = Sgn(L) * A * Sqr(2 * Tau) * BIClothoidX
                TMP = BigIntMulS(Tau, X2, M)
                TMP2 = BISqr(TMP, M)
                'A * Sqr(2 * Tau)
                TMP3 = BigIntMulS(TMP2, A, M)
                TMP4 = BigIntMulS(BIClothoidX, TMP3, M)
                If L.BigSgn = "-" And TMP4.BigSgn = "-" Then
                    TMP4.BigSgn = "+"
                ElseIf L.BigSgn = "-" And TMP4.BigSgn = "+" Then
                    TMP4.BigSgn = "-"
                End If
                'BIClothoidY = Sgn(L) * A * Tau * Sqr(2 * Tau) * BIClothoidY
                'A * Sqr(2 * Tau) * Tau
                TMP = BigIntMulS(Tau, TMP3, M)
                TMP5 = BigIntMulS(BIClothoidY, TMP, M)
                If L.BigSgn = "-" And TMP5.BigSgn = "-" Then
                    TMP5.BigSgn = "+"
                ElseIf L.BigSgn = "-" And TMP5.BigSgn = "+" Then
                    TMP5.BigSgn = "-"
                End If
                'Zbg
                BIClothoidX = BIKetaN(TMP4, CLng(Digit))
                BIClothoidY = BIKetaN(TMP5, CLng(Digit))
                'W ߒlZbg
                ReDim BIClothoidXY(0 To 1)
                BIClothoidXY(0) = BIClothoidX
                BIClothoidXY(1) = BIClothoidY
            End If
            'I
            BIClothoid = True
        End If
    End If
Exit Function
ERR:
'Resume Next
    Erase BIClothoidXY
    BIClothoid = False
End Function
