Attribute VB_Name = "BigInt_Functions_A"
Option Explicit
'
'------------------------------------------------------------------------------
'  VBAő{Zs߂̃Cup  Z֐`
'    WW[ BigInt_Definition_1`3   K{
'    WW[ BigInt_Definition_SWTAPI K{
'    WW[ BigInt_Functions_1 `3   K{
'    WW[ BigInt_Functions_FFT     K{
'------------------------------------------------------------------------------
'
'pubN萔
Public Const PaiLimitN     As Long = 100000    '~  vZ  (/6,/2,/4)
'------------------------------------------------------------------------------
'pubNϐ
'------------------------------------------------------------------------------
'vCx[g萔
'------------------------------------------------------------------------------
'vCx[gϐ
'------------------------------------------------------------------------------
'
'̃W[̊֐ꗗ
'------------------------------------------------------------------------------
' ======= Sub ֐ ===============================================
' ======= Function ֐ ==========================================
'    ~  [AGM ASY]                           BIPiCalc(Digit As Long, Optional SqrLastFLG As Boolean = False, _
'                                                                  Optional debug_ As Variant, Optional debug2_ As Variant, Optional debug3_ As Variant) As BigIntType
'    ~  [̌]                                 BIPiTCalcBIPiTCalc(Digit As Long, _
'                                                                            Optional debug_ As Variant, Optional debug2_ As Variant, Optional debug3_ As Variant) As BigIntType
'    ~  [/6=(2k)!/{(2^(4k+1))*((k!)^2)*(2k+1)}]  BIPi6Calc(Digit As Long, Optional N As Long = PaiLimitN, _
'                                                                   Optional debug_ As Variant, Optional debug2_ As Variant, Optional debug3_ As Variant) As BigIntType
'  ******ixA肪ȒPłȂ̂ŌvZl͐mł͂܂j**************************************
'    ~  [/2=((2k-1)!!/2k!!)/(2k+1)]              BIPi2Calc(Digit As Long, Optional N As Long = PaiLimitN, _
'                                                                   Optional debug_ As Variant, Optional debug2_ As Variant, Optional debug3_ As Variant) As BigIntType
'    ~  [/4=(-1)^k(1/(2k+1))]                    BIPi4Calc(Digit As Long, Optional N As Long = PaiLimitN, _
'                                                                   Optional debug_ As Variant, Optional debug2_ As Variant, Optional debug3_ As Variant) As BigIntType
'------------------------------------------------------------------------------
'
'ỹW[̍XVz
'       ɂ            o[W                                  XVe
' ---------------+----------------------------------+---------+-----------------------------------------------------------------------------------
'    [2010/05/30] Ver.1.90 Alpha EditioniJŁj  VKǉ  ~[̌] (BIPiTCalc)ǉ
'                                                     dlύX  ~(BIPiAMGCalcBIPiCalc)  vV[WύX
'                                                     ɘa  ~  vZ pubN萔(PaiLimitN) 1000005000
'    [2009/12/07] Ver.1.87 Alpha EditioniJŁj  dlύX  ~(AGM)  SqrLastFLGǉ
'    [2009/11/10] Ver.1.86 Alpha EditioniJŁj  Pp  ~(BIPi6Calc,BIPi2Calc,BIPi4Calc)  Z̐Pp (pubN萔:PaiLimitC)
'                                                     Pp  ~(BIPi6Calc,BIPi2Calc,BIPi4Calc)  vZ񐔂̐Ppiȍ~͈ȗ̌vZ񐔂̂Ă̂ݎgpj
'    [2009/01/04] Ver.1.80 Alpha EditioniJŁj  Pp  ~(AGM) (PaiLimitC)Ɛ(PaiLimitN_AGM)
'    [2008/11/19] Ver.1.70 Alpha EditioniJŁj  C      ~(BIPiCalc)  l(SQRT_SQRT_EPSILON)̎ZoC  <œKlɏC>
'    [2008/11/06] Ver.1.69 Alpha EditioniJŁj  ɘa  ~   pubN萔(PaiLimitC) 300025001
'                                                           pubN萔(PaiLimitN_AGM=20)
'                                                         X  ~(AGM)  lvZȂ
'    [2008/10/05] Ver.1.67 Alpha EditioniJŁj  VKǉ  ~(/6)
'                                                           pubN萔(PaiLimitC=5001, PaiLimitN=5000)
'                                                         X  ~(BIPiCalc4,BIPiCalc2)  @
'                                                         X  ֐ύX(BIPiCalc4BIPiCalc2, BIPiCalc2BIPiCalc3)
'                                                         X  ~(BIPiCalc4)E~(BIPiCalc2)  ύX
'    [2008/06/20] Ver.1.58 Alpha EditioniJŁj      X  W[(BigInt_Functions_ABigInt_Functions_3_2)
'    [2008/06/18] Ver.1.57 Alpha EditioniJŁj      X  BIPiCalc  őJԂvZ10(20)
'    [2008/06/09] Ver.1.24 Alpha EditioniJŁj  C      l`FbN
'    [2008/06/05] Ver.0.98 Alpha EditioniJŁj  VKǉ
'------------------------------------------------------------------------------
'  ӎ
'    ẼW[݂̂ł͍쓮ł܂
'      VBAő{Zs߂̃Cu(BigInt_Definition_1`2,BigInt_Functions_1)Kvł
'    ẼW[́AׂĂɂ
'      ȗ\ debug_, debug2_, debug3_ 폜ꍇ
'      ڈ̃}[N ,  zuĂ܂
'------------------------------------------------------------------------------
'

'~
'------------------------------------------------------------------------------
'  YƂ FFT  AGM ɂ~vZvOŎĂ
'  ~vZ̃ASYQlɂ܂B
'    URL:http://www.kurims.kyoto-u.ac.jp/~ooura/pi_fft-j.html
'
'  ---- a formula based on the AGM (Arithmetic-Geometric Mean) ----
'    c = sqrt(0.125);
'    a = 1 + 3 * c;
'    b = sqrt(a);
'    e = b - 0.625;
'    b = 2 * b;
'    c = e - c;
'    a = a + e;
'    npow = 4;
'    do {
'        npow = 2 * npow;
'        e = (a + b) / 2;
'        b = sqrt(a * b);
'        e = e - b;
'        b = 2 * b;
'        c = c - e;
'        a = e + b;
'    } while (e > SQRT_SQRT_EPSILON);
'    e = e * e / 4;
'    a = a + b;
'    pi = (a * a - e - e / 2) / (a * c - e) / npow;
'  ---- modification ----
'    This is a modified version of Gauss-Legendre formula
'    (by T.Ooura). It is faster than original version.
'------------------------------------------------------------------------------
Public Function BIPiAMGCalc(Digit As Long, Optional SqrLastFLG As Boolean = False, _
                         Optional debug_ As Variant, Optional debug2_ As Variant, Optional debug3_ As Variant) As BigIntType
'  ΁^~ [AGM ASY]
'------------------------------------------------------------------------------
'    Digit       [Integer]     ߂錅i_ȉ̌{Pj
'        SqrLastFLG  [Boolean]     iȗj̍ŏIvZLiȗ False:vZj
'        debug_      [Variant]     iȗj[U[tH[̃IuWFNg vZߒ̏o͐
'        debug2_     [Variant]     iȗj[U[tH[̃IuWFNg vZԂ̏o͐
'        debug3_     [Variant]     iȗj[U[tH[̃IuWFNg ڍׂȉߒ̏o͐
'  ߒl  I    [BigIntType]  [U[`^
'@@  @ُI    [BigIntType]  [U[`^̃G[l (BigSgn:""(ASCIIR[hԍ0), BigInt:"", BigExp:0, BigDat:Empty)
'------------------------------------------------------------------------------
'    ̉~vZŋ߂֐ŁA
'        ʏ́A\擾 BIPi ֐gp
'          ߂錅{PŎľܓlߒlƂȂ܂
'          o[Wł͕(Z){glbNŉZxo܂
'            h񎟎̔Ō{ɂȂC킸 26̃[v̔14ȏ̌ʂ܂Dh
'          ̉ZvOł́A200,001͂PSŎ܂iQl vZԂQƁj
'            AݒɏԂ܂
'------------------------------------------------------------------------------
'  
'------------------------------------------------------------------------------
'  ˑ  ֐  BISqr,
'              BICBit, BigIntAdd, BigIntSub, BigIntMul,
'              BIIsError, BIIsAEqualB, BIIsBOrMore,
'              Bigint2String, BIKetaN
'              BIWarnningDialog,
'              DigitCheck, SetBigIntDigitCalculations,
'              Wait
'        萔  BigIntLimit
'        ϐ  BigIntErrFLG
'              NowTime
'  ̃Xg͒ڗpĂ֐E萔Eϐ̂݁iVBAg݊֐E萔j
'------------------------------------------------------------------------------
'  
'------------------------------------------------------------------------------
'  Ql  vZ
'          ʓ͔vZ̉
'
'          (Pentium 4 2.80C GHz)
'            [By Ver.1.69 BigInt_Demo(vZߒo:ON)]
'             ߂錅  50,001  12 50      x (12)i_ȉ5000j
'
'            [By Ver.1.72 BigInt_Demo(vZߒo:ON)]
'                            200               3b x ( 4)
'                            500              20b x ( 5)
'                          1,000              25b x ( 6)
'                          2,000              50b x ( 7)
'                          5,000          3 50b x ( 8)
'                         10,000         14 50b x ( 9)
'                         20,000   1 15      x (10)
'                         30,000   2 30      x (11)
'
'            [By Ver.1.80 BigInt_Demo(vZߒo:ON)]
'                            201              04b x ( 4)i_ȉ200j
'                            501              23b x ( 5)i_ȉ500j
'                          1,001              25b x ( 6)i_ȉ1000j
'                          2,001              50b x ( 7)i_ȉ2000j
'                          5,001          1 40b x ( 8)i_ȉ5000j
'                         10,001          3 45b x ( 9)i_ȉ10000j
'                         20,001         10 00b x (10)i_ȉ20000j
'                         30,001         14 30b x (11)i_ȉ30000j
'                         50,001         36 45b x (12)i_ȉ50000j
'                        100,001   1 42 00b x (13)i_ȉ100000j
'
'            [By Ver.1.81 BigInt_Demo(vZߒo:ON)]
'                        200,001   35500b x (14)i_ȉ200000j
'
'          (Pentium 4 3.20 GHz)
'            [By Ver.1.87 BigInt_Demo(vZߒo:ON)]
'                          5,001              25b x ( 8)i_ȉ5000j
'                         10,001              50b x ( 9)i_ȉ10000j
'                         20,001          2 00b x (10)i_ȉ20000j
'                         30,001          2 25b x (11)i_ȉ30000j
'                         50,001          6 25b x (12)i_ȉ50000j
'                        100,001         14 15b x (13)i_ȉ100000j
'                        200,001         39 00b x (14)i_ȉ200000j
'
'                < ŏǏvZ͏ȗ>
'                          5,001              15b x ( 8)i_ȉ5000j
'                         10,001              35b x ( 9)i_ȉ10000j
'                         20,001          1 25b x (10)i_ȉ20000j
'                         30,001          1 50b x (11)i_ȉ30000j
'                         50,001          4 25b x (12)i_ȉ50000j
'                        100,001         10 15b x (13)i_ȉ100000j
'                        200,001         25 15b x (14)i_ȉ200000j
'
'            [By Ver.1.90 BigInt_Demo(vZߒo:ON)]
'                < ŏǏvZ͏ȗ>
'                   ߂錅(_ȉ)
'                          5,000            20b 
'                         10,000            40b x
'                         20,000          1 40b x
'                         30,000          1 50b x
'                         50,000          4 20b x
'                        100,000         10 40b x
'                        200,000         22 00b x
'------------------------------------------------------------------------------
Dim EPSILON            As BigIntType   '߂ŏ̐ 1E-(Digit-1) [Digit-1:_ȉ̌]
                                       '                              [Digit ɂ͏_ȏ"3."܂܂Ă̂-1]
Dim SQRT_SQRT_EPSILON  As BigIntType   'l (EPSILON)
'
Dim CC       As BigIntType   '
Dim X1       As BigIntType   '萔  1
Dim X2       As BigIntType   '      2
Dim X3       As BigIntType   '      3
Dim X4       As BigIntType   '      4
Dim X02      As BigIntType   '      1/2=0.5
Dim X04      As BigIntType   '      1/4=0.25
Dim X0625    As BigIntType   '      0.625
Dim A        As BigIntType   '
Dim B        As BigIntType   '
Dim C        As BigIntType   '
Dim d        As BigIntType   '
Dim E        As BigIntType   'l
Dim E0       As BigIntType   '           Ol
Dim TMP      As BigIntType   '
Dim TMP1     As BigIntType   '
Dim TMP2     As BigIntType   '
Dim TMP3     As BigIntType   '
Dim npow     As BigIntType   '
Dim I        As Long
Dim K        As Long
Dim M        As Long         'vZ
Dim dDigit   As Long         ']T
Dim dStepN   As Long         'o͕px
Dim OldTime  As Single
Dim NowTimeD As Double
Dim OldTimeD As Double
Dim DebugTxt As String
    On Error GoTo ERR:
    '
    If Not IsMissing(debug2_) Then Call BI_debug2(debug2_, 0#, OldTime)
    If Not IsMissing(debug_) Then NowTimeD = CDbl(Timer)
    If Not IsMissing(debug_) Then OldTimeD = NowTimeD
    '
    '߂錅̃`FbN
    If Not DigitCheck(Digit) Then Exit Function
    '萔
    X1 = BICBit(1)
    X2 = BICBit(2)
    X3 = BICBit(3)
    X4 = BICBit(4)
    X02 = BICBit("0.5")
    X04 = BICBit("0.25")
    X0625 = BICBit("0.625")
    '
    K = 0
    dDigit = 5   ']T
    dStepN = 1   'o̓Xebv
    'vZ
    M = SetBigIntDigitCalculations(Digit, dDigit)
    '---------------------------------------------------------------------
        '
        If Not IsMissing(debug_) Then
            DebugTxt = ""
            DebugTxt = DebugTxt & " " & vbCr
            DebugTxt = DebugTxt & "-----------------------------------------------------------" & vbCr
            DebugTxt = DebugTxt & "  YƂFFTAGM ɂ~vZvO" & vbCr
            DebugTxt = DebugTxt & "  Ă~vZ̃ASYQlɂ܂B" & vbCr
            DebugTxt = DebugTxt & "    URL:http://www.kurims.kyoto-u.ac.jp/~ooura/pi_fft-j.html" & vbCr
            DebugTxt = DebugTxt & "" & vbCr
            DebugTxt = DebugTxt & "  ---- a formula based on the AGM (Arithmetic-Geometric Mean) ----" & vbCr
            DebugTxt = DebugTxt & "    c = sqrt(0.125);" & vbCr
            DebugTxt = DebugTxt & "    a = 1 + 3 * c;" & vbCr
            DebugTxt = DebugTxt & "    b = sqrt(a);" & vbCr
            DebugTxt = DebugTxt & "    e = b - 0.625;" & vbCr
            DebugTxt = DebugTxt & "    b = 2 * b;" & vbCr
            DebugTxt = DebugTxt & "    c = e - c;" & vbCr
            DebugTxt = DebugTxt & "    a = a + e;" & vbCr
            DebugTxt = DebugTxt & "    npow = 4;" & vbCr
            DebugTxt = DebugTxt & "    do {" & vbCr
            DebugTxt = DebugTxt & "        npow = 2 * npow;" & vbCr
            DebugTxt = DebugTxt & "        e = (a + b) / 2;" & vbCr
            DebugTxt = DebugTxt & "        b = sqrt(a * b);" & vbCr
            DebugTxt = DebugTxt & "        e = e - b;" & vbCr
            DebugTxt = DebugTxt & "        b = 2 * b;" & vbCr
            DebugTxt = DebugTxt & "        c = c - e;" & vbCr
            DebugTxt = DebugTxt & "        a = e + b;" & vbCr
            DebugTxt = DebugTxt & "    } while (e > SQRT_SQRT_EPSILON);" & vbCr
            DebugTxt = DebugTxt & "    e = e * e / 4;" & vbCr
            DebugTxt = DebugTxt & "    a = a + b;" & vbCr
            DebugTxt = DebugTxt & "    pi = (a * a - e - e / 2) / (a * c - e) / npow;" & vbCr
            DebugTxt = DebugTxt & "  ---- modification ----" & vbCr
            DebugTxt = DebugTxt & "    This is a modified version of Gauss-Legendre formula" & vbCr
            DebugTxt = DebugTxt & "    (by T.Ooura). It is faster than original version." & vbCr
            DebugTxt = DebugTxt & "-----------------------------------------------------------" & vbCr
            DebugTxt = DebugTxt & " SQRT_SQRT_EPSILON = EPSILON" & vbCr
            DebugTxt = DebugTxt & " EPSILON: ߂ŏ = 10^(_ȉ̌)" & vbCr
        End If
        If Not IsMissing(debug_) Then Call BI_debug1(debug_, DebugTxt, 0#)
        If Not IsMissing(debug_) Then DebugTxt = " " & vbCr & _
                                                 "M(vZ)(߂錅){(]T)" & Digit & "+" & dDigit & "" & CStr(M) & "" & vbCr
        If Not IsMissing(debug_) Then Call BI_debug1(debug_, DebugTxt, 0.00001)
        If Not IsMissing(debug2_) Then Call BI_debug2(debug2_, 0.00001, OldTime)
        '
    '------------------------------------------------------------
    '߂ŏ̐ EPSILON = 1E-(Digit-1)
    EPSILON = X1
    EPSILON.BigExp = -1 * (Digit - 1)
    'l SQRT_SQRT_EPSILON = EPSILON = EPSILON^(0.25)  <ׂ͒x̂ŕQŎZo>
    TMP = BISqr(EPSILON, M)
    SQRT_SQRT_EPSILON = BISqr(TMP, Digit)
    '------------------------------------------------------------
        '
        If Not IsMissing(debug_) Then
            DebugTxt = "@@EPSILON(߂ŏ̐)  " & BI2ExpN(EPSILON, 16) & vbCr & _
                                                         "--------------------------------------------------" & vbCr
            If EPSILON.BigExp Mod 2 = 0 Then
                DebugTxt = "@EPSILON  " & BI2ExpN(TMP, 16) & vbCr & DebugTxt
                If (TMP.BigExp Mod 2 = 0) Then
                    DebugTxt = "EPSILON(l)  " & BI2ExpN(SQRT_SQRT_EPSILON, 16) & vbCr & DebugTxt
                Else
                    DebugTxt = "EPSILON(l)  " & BI2ExpN(SQRT_SQRT_EPSILON, 16) & vbCr & DebugTxt
                End If
            Else
                DebugTxt = "EPSILON(l)  " & BI2ExpN(SQRT_SQRT_EPSILON, 16) & vbCr & _
                      "@EPSILON  " & BI2ExpN(TMP, 16) & vbCr & DebugTxt
            End If
            DebugTxt = " " & vbCr & _
                  "EEEľvZɏԂ܂EEE" & vbCr & _
                  vbCr & _
                  "--------------------------------------------------" & vbCr & DebugTxt
        End If
        If Not IsMissing(debug_) Then Call BI_debug1(debug_, DebugTxt, 0.00001)
        If Not IsMissing(debug_) Then OldTimeD = CDbl(Timer)
        If Not IsMissing(debug2_) Then Call BI_debug2(debug2_, 0.00001, OldTime)
        '
    '------------------------------------------------------------
    'c = sqrt(0.125)
    TMP = BICBit("0.125")
        '
        If Not IsMissing(debug_) Then NowTimeD = CDbl(Timer)
        If Not IsMissing(debug_) Then DebugTxt = "TMP = BICBit(""0.125"")        " & " [" & Format(NowTimeD - OldTimeD, "#0.000 Sec") & "]" & vbCr & _
                                                 "--------------------------------------------------" & vbCr
        If Not IsMissing(debug_) Then OldTimeD = NowTimeD
        If Not IsMissing(debug_) Then Call BI_debug1(debug_, DebugTxt, 0.00001)
        '
    C = BISqr(TMP, M, , SqrLastFLG)
        '
        If Not IsMissing(debug_) Then NowTimeD = CDbl(Timer)
        If Not IsMissing(debug_) Then DebugTxt = "c = BISqr(TMP, M)            " & " [" & Format(NowTimeD - OldTimeD, "#0.000 Sec") & "]" & vbCr
        If Not IsMissing(debug_) Then OldTimeD = NowTimeD
        If Not IsMissing(debug_) Then Call BI_debug1(debug_, DebugTxt, 0.00001)
        '
    'a = 1 + 3 * c
    TMP = BigIntMul(C, X3, M)
        '
        If Not IsMissing(debug_) Then NowTimeD = CDbl(Timer)
        If Not IsMissing(debug_) Then DebugTxt = "TMP = BigIntMul(c, X3, M)    " & " [" & Format(OldTimeD - OldTimeD, "#0.000 Sec") & "]" & vbCr
        If Not IsMissing(debug_) Then OldTimeD = NowTimeD
        If Not IsMissing(debug_) Then Call BI_debug1(debug_, DebugTxt, 0.00001)
        '
    A = BigIntAdd(TMP, X1, M)
        '
        If Not IsMissing(debug_) Then NowTimeD = CDbl(Timer)
        If Not IsMissing(debug_) Then DebugTxt = "a = BigIntAdd(TMP, X1, M)    " & " [" & Format(NowTimeD - OldTimeD, "#0.000 Sec") & "]" & vbCr
        If Not IsMissing(debug_) Then OldTimeD = NowTimeD
        If Not IsMissing(debug_) Then Call BI_debug1(debug_, DebugTxt, 0.00001)
        '
    'b = sqrt(a)
    B = BISqr(A, M, , SqrLastFLG)
        '
        If Not IsMissing(debug_) Then NowTimeD = CDbl(Timer)
        If Not IsMissing(debug_) Then DebugTxt = "b = BISqr(a, M)              " & " [" & Format(NowTimeD - OldTimeD, "#0.000 Sec") & "]" & vbCr
        If Not IsMissing(debug_) Then OldTimeD = NowTimeD
        If Not IsMissing(debug_) Then Call BI_debug1(debug_, DebugTxt, 0.00001)
        '
    'e = b - 0.625
    E = BigIntSub(B, X0625, M)
        '
        If Not IsMissing(debug_) Then NowTimeD = CDbl(Timer)
        If Not IsMissing(debug_) Then DebugTxt = "e = BigIntSub(b, X0625, M)   " & " [" & Format(NowTimeD - OldTimeD, "#0.000 Sec") & "]" & vbCr
        If Not IsMissing(debug_) Then OldTimeD = NowTimeD
        If Not IsMissing(debug_) Then Call BI_debug1(debug_, DebugTxt, 0.00001)
        '
    'b = 2 * b
    B = BigIntMul(B, X2, M)
        '
        If Not IsMissing(debug_) Then NowTimeD = CDbl(Timer)
        If Not IsMissing(debug_) Then DebugTxt = "b = BigIntMul(b, X2, M)      " & " [" & Format(NowTimeD - OldTimeD, "#0.000 Sec") & "]" & vbCr
        If Not IsMissing(debug_) Then OldTimeD = NowTimeD
        If Not IsMissing(debug_) Then Call BI_debug1(debug_, DebugTxt, 0.00001)
        '
    'c = e - c
    C = BigIntSub(E, C, M)
        '
        If Not IsMissing(debug_) Then NowTimeD = CDbl(Timer)
        If Not IsMissing(debug_) Then DebugTxt = "c = BigIntSub(e, c, M)       " & " [" & Format(NowTimeD - OldTimeD, "#0.000 Sec") & "]" & vbCr
        If Not IsMissing(debug_) Then OldTimeD = NowTimeD
        If Not IsMissing(debug_) Then Call BI_debug1(debug_, DebugTxt, 0.00001)
        '
    'a = a + e
    A = BigIntAdd(A, E, M)
        '
        If Not IsMissing(debug_) Then NowTimeD = CDbl(Timer)
        If Not IsMissing(debug_) Then DebugTxt = "a = BigIntAdd(a, e, M)       " & " [" & Format(NowTimeD - OldTimeD, "#0.000 Sec") & "]" & vbCr
        If Not IsMissing(debug_) Then OldTimeD = NowTimeD
        If Not IsMissing(debug_) Then Call BI_debug1(debug_, DebugTxt, 0.00001)
        '
    'npow = 4
    npow = X4
        '
        If Not IsMissing(debug_) Then NowTimeD = CDbl(Timer)
        If Not IsMissing(debug_) Then DebugTxt = "--------------------------------------------------" & vbCr & _
                                                 "npow = X4                    " & " [" & Format(NowTimeD - OldTimeD, "#0.000 Sec") & "]" & vbCr
        If Not IsMissing(debug_) Then Call BI_debug1(debug_, DebugTxt, 0.00001)
        '
    '------------------------------------------------------------
    '
    If Not IsMissing(debug_) Then DebugTxt = "--------------------------------------------------" & vbCr & _
                                             " K: vZ" & vbCr & _
                                             " L: E̗L" & vbCr & _
                                             " T: vZ" & vbCr & _
                                             " E: l [: E < EPSILON]" & vbCr & _
                                             "--------------------------------------------------" & vbCr & _
                                             " " & vbCr & _
                                             "EEEľvZ@EEE" & vbCr & vbCr
    If Not IsMissing(debug_) Then Call BI_debug1(debug_, DebugTxt, 0.00001)
    If Not IsMissing(debug2_) Then Call BI_debug2(debug2_, 0.00001, OldTime)
    'ڍׂȉߒo
    If Not IsMissing(debug3_) Then DebugTxt = "--------------------------------------------------" & vbCr & _
                                              "K:0, " & "T:" & Format(NowTime - OldTime, "#0.000 Sec") & vbCr & _
                                              "A: " & Bigint2String(A) & vbCr & _
                                              "B: " & Bigint2String(B) & vbCr & _
                                              "C: " & Bigint2String(C) & vbCr & _
                                              "E: " & Bigint2String(E) & vbCr & _
                                              "npow: " & Bigint2String(npow) & vbCr & _
                                              "--------------------------------------------------" & vbCr
    If Not IsMissing(debug3_) Then Call BI_debug1(debug_, DebugTxt, 0.00001)
    '
    '------------------------------------------------------------
    Call Wait(0.0001)   'DoEvents
    E = BICBit(0)
    '
    Do
        K = K + 1
        E0 = E
        '------------------------------------------------------------
        'npow = 2 * npow
        npow = BigIntMul(npow, X2, M)
            '
            'ڍׂȉߒo
            If Not IsMissing(debug3_) Then Call BI_debug1(debug_, "K: " & CStr(K) & "(1), npow: " & Bigint2String(npow) & vbCr, 0.00001)
            '
        'e = (a + b) / 2
        TMP = BigIntAdd(A, B, M)
        E = BigIntMul(TMP, X02, M)              'Xs[hAbv "/2" łȂ "*0.5"
            '
            'ڍׂȉߒo
            If Not IsMissing(debug3_) Then Call BI_debug1(debug_, "K: " & CStr(K) & "(2), E: " & Bigint2String(E) & vbCr, 0.00001)
            '
        'b = sqrt(a * b)
        TMP = BigIntMul(A, B, M)
        B = BISqr(TMP, M, , SqrLastFLG)
            '
            'ڍׂȉߒo
            If Not IsMissing(debug3_) Then Call BI_debug1(debug_, "K: " & CStr(K) & "(3), B:" & Bigint2String(B) & vbCr, 0.00001)
            '
        'e = e - b
        E = BigIntSub(E, B, M)
            '
            'ڍׂȉߒo
            If Not IsMissing(debug3_) Then Call BI_debug1(debug_, "K: " & CStr(K) & "(4), E: " & Bigint2String(E) & vbCr, 0.00001)
            '
        'b = 2 * b
        B = BigIntMul(B, X2, M)
            '
            'ڍׂȉߒo
            If Not IsMissing(debug3_) Then Call BI_debug1(debug_, "K: " & CStr(K) & "(5), B: " & Bigint2String(B) & vbCr, 0.00001)
            '
        'c = c - e
        C = BigIntSub(C, E, M)
            '
            'ڍׂȉߒo
            If Not IsMissing(debug3_) Then Call BI_debug1(debug_, "K: " & CStr(K) & "(6), C: " & Bigint2String(C) & vbCr, 0.00001)
            '
        'a = e + b
        A = BigIntAdd(E, B, M)
            '
            'ڍׂȉߒo
            If Not IsMissing(debug3_) Then Call BI_debug1(debug_, "K: " & CStr(K) & "(7), A: " & Bigint2String(A) & vbCr, 0.00001)
            '
        '------------------------------------------------------------
        If K Mod dStepN = 0 Then
            Call Wait(0.0001)   'DoEvents
            '
            If Not IsMissing(debug_) Then DebugTxt = "K: " & CStr(K) & _
                                                     ", L: " & CStr(Abs(Len(E.BigInt) + E.BigExp)) & _
                                                     ", T: " & Format(NowTime - OldTime, "#0.000 Sec") & _
                                                     ", E: " & Bigint2String(E) & vbCr & vbCr
            If Not IsMissing(debug_) Then Call BI_debug1(debug_, DebugTxt, 0#)
            If Not IsMissing(debug2_) Then Call BI_debug2(debug2_, 0.00001, OldTime)
            '
        End If
        ' -----------------------------------------------------------
        If BIIsBOrMore(SQRT_SQRT_EPSILON, E) Then
        ' (SQRT_SQRT_EPSILON>=E)
            '
            If Not IsMissing(debug_) Then DebugTxt = "i߂錅ȏ́jvZlA܂B" & vbCr & _
                                                     "I" & vbCr & vbCr
            If Not IsMissing(debug_) Then Call BI_debug1(debug_, DebugTxt, 0.00001)
            If Not IsMissing(debug2_) Then Call BI_debug2(debug2_, 0.00001, OldTime)
            '
            Exit Do
        End If
        If BIIsAEqualB(E, E0) Then
        'ω
            '
            If Not IsMissing(debug_) Then DebugTxt = "vZlA߂錅ȉŎ܂B" & vbCr & _
                                                     "ُI" & vbCr
            If Not IsMissing(debug_) Then Call BI_debug1(debug_, DebugTxt, 0.00001)
            If Not IsMissing(debug2_) Then Call BI_debug2(debug2_, 0.00001, OldTime)
            '
            Exit Function
        ElseIf BIIsError(E) Then
        'G[l
            '
            If Not IsMissing(debug_) Then DebugTxt = "vZlAG[łB" & vbCr & _
                                                     "ُI" & vbCr
            If Not IsMissing(debug_) Then Call BI_debug1(debug_, DebugTxt, 0.00001)
            If Not IsMissing(debug2_) Then Call BI_debug2(debug2_, 0.00001, OldTime)
            '
            Exit Function
        End If
        '---------------------------------------------------------------
    Loop While BIIsBOrMore(E, SQRT_SQRT_EPSILON)   'E >= SQRT_SQRT_EPSILON
                                                   'ۂɂ͏L̔ Exit Do (܂ Exit Function) ̂łLoopIP[X͖
    '
    If Not IsMissing(debug_) Then DebugTxt = "----------------------------------" & vbCr & _
                                             "  Do ` Loop @" & vbCr & _
                                             "----------------------------------" & vbCr
    If Not IsMissing(debug_) Then Call BI_debug1(debug_, DebugTxt, 0.00001)
    If Not IsMissing(debug2_) Then Call BI_debug2(debug2_, 0.00001, OldTime)
    '
    'ΌvZ
    'e = e * e / 4
    TMP = BigIntMul(E, E, M)
    E = BigIntMul(TMP, X04, M)
    'a = a + b
    A = BigIntAdd(A, B, M)
    '
    'pi = (a * a - e - e / 2) / (a * c - e) / npow
    '(a * a - e - e / 2)
    TMP = BigIntMul(A, A, M)
    TMP1 = BigIntSub(TMP, E, M)
    TMP = BigIntMul(E, X02, M)
    TMP1 = BigIntSub(TMP1, TMP, M)
    ' / (a * c - e)
    TMP2 = BigIntMul(A, C, M)
    TMP = BigIntSub(TMP2, E, M)
    TMP2 = BIReciprocal(TMP, M)
    ' / npow
    TMP3 = BIReciprocal(npow, M)
    '(a * a - e - e / 2) / (a * c - e)
    TMP = BigIntMul(TMP1, TMP2, M)
    '̌vZ
    CC = BigIntMul(TMP, TMP3, M)
    '
    If Not IsMissing(debug2_) Then Call BI_debug2(debug2_, 0.00001, OldTime)
    '
    '
    CC = BIKetaN(CC, Digit)
    'ߒlZbg
    BIPiAMGCalc = CC
    '
    If Not IsMissing(debug_) Then DebugTxt = "----------------------------------" & vbCr & _
                                             "  ΌvZ@" & vbCr & _
                                             "----------------------------------" & vbCr
    If Not IsMissing(debug_) Then Call BI_debug1(debug_, DebugTxt, 0.00001)
    If Not IsMissing(debug2_) Then Call BI_debug2(debug2_, 0.00001, OldTime)
    '
Exit Function
ERR:
'Resume Next
    BigIntErrFLG = ERR.number
    Call BIWarnningDialog(Error(BigIntErrFLG) & vbCr & vbCr, "BIPiAMGCalc")
End Function
'~
Public Function BIPiTCalc(Digit As Long, Optional debug_ As Variant, Optional debug2_ As Variant, Optional debug3_ As Variant) As BigIntType
'  ΁^~  ̌
'------------------------------------------------------------------------------
'    Digit       [Integer]     ߂錅i_ȉ̌{Pj
'        debug_      [Variant]     iȗj[U[tH[̃IuWFNg vZߒ̏o͐
'        debug2_     [Variant]     iȗj[U[tH[̃IuWFNg vZԂ̏o͐
'        debug3_     [Variant]     iȗj[U[tH[̃IuWFNg ڍׂȉߒ̏o͐
'  ߒl  I    [BigIntType]  [U[`^
'@@  @ُI    [BigIntType]  [U[`^̃G[l (BigSgn:""(ASCIIR[hԍ0), BigInt:"", BigExp:0, BigDat:Empty)
'------------------------------------------------------------------------------
'    ~vZǐjŋ߂֐
'          ߂錅{PŎľܓlߒlƂȂ܂
'          ʏ́A\擾 BIPi ֐gp
'
'        ̌
'           = 48*Atn(1/49) + 128*Atn(1/57) - 20*Atn(1/239) + 48*Atn(1/110443)
'
'          cÑX[p[Rs[^p
'          ΂PQSPPvZ(2005N)Ɏg
'          }`̌̉ǔ
'
'          cz|y|W http://www.super-computing.org/index-j.html
'------------------------------------------------------------------------------
'  
'------------------------------------------------------------------------------
'  ˑ  ֐  BICBit, BigIntAdd, BigIntMul, BIAtnR_BS
'              BIKetaN,
'              BIWarnningDialog,
'              DigitCheck, SetBigIntDigitCalculations,
'              Wait,
'              BI_debug1, BI_debug2
'        萔
'        ϐ  BigIntErrFLG
'  ̃Xg͒ڗpĂ֐E萔Eϐ̂݁iVBAg݊֐E萔j
'------------------------------------------------------------------------------
'  
'------------------------------------------------------------------------------
'  Ql  vZ (Pentium 4 3.20 GHz)
'            [By Ver.1.90 BigInt_Demo(vZߒo:ON)]
'             ߂錅(_ȉ)   5,000            20b x
'                                     10,000            45b x
'                                     20,000          1 30b x
'                                     30,000          2 10b x
'                                     50,000          4 00b x
'                                    100,000          9 10b x
'                                    200,000         22 00b x
'------------------------------------------------------------------------------
'  ̑  ȂׂāAAGMASY(BIPiCalc)ARXgiԁj܂
'------------------------------------------------------------------------------
Dim CC        As BigIntType   '
Dim Atn49     As BigIntType   'Atn(1/49)
Dim Atn57     As BigIntType   'Atn(1/57)
Dim Atn239    As BigIntType   'Atn(1/239)
Dim Atn110443 As BigIntType   'Atn(1/110443)
Dim X1        As BigIntType   '萔 1
Dim X20       As BigIntType   '    20
Dim X48       As BigIntType   '    48
Dim X49       As BigIntType   '    49
Dim X57       As BigIntType   '    57
Dim X128      As BigIntType   '   128
Dim X239      As BigIntType   '   239
Dim X110443   As BigIntType   '110443
Dim TMP1      As BigIntType   '
Dim TMP2      As BigIntType   '
Dim TMP3      As BigIntType   '
Dim TMP4      As BigIntType   '
Dim TMP5      As BigIntType   '
Dim TMP6      As BigIntType   '
Dim M         As Long         'vZ
Dim dDigit    As Long         ']T
Dim OldTime   As Single       '
Dim DebugTxt  As String
    On Error GoTo ERR:
    '
    If Not IsMissing(debug2_) Then Call BI_debug2(debug2_, 0#, OldTime)
    '
    '߂錅̃`FbN
    If Not DigitCheck(Digit) Then Exit Function
    '萔
    X1 = BICBit(1)
    X20 = BICBit(20)
    X48 = BICBit(48)
    X49 = BICBit(49)
    X57 = BICBit(57)
    X128 = BICBit(128)
    X239 = BICBit(239)
    X110443 = BICBit(110443)
    ']T
    dDigit = 5
    'vZ
    M = SetBigIntDigitCalculations(Digit, dDigit)
    '
    If Not IsMissing(debug_) Then DebugTxt = "Atn(1/49) vZEEE" & vbCr & _
                                             "" & vbCr & _
                                             "" & vbCr & _
                                             "-------------------------------------------" & vbCr & _
                                             "    ~vZǐjŋ߂܂   " & vbCr & _
                                             "       = 48*Atn(1/49) + 128*Atn(1/57) - 20*Atn(1/239) + 48*Atn(1/110443)" & vbCr & _
                                             "-------------------------------------------" & vbCr & _
                                             " " & vbCr
    If Not IsMissing(debug_) Then Call BI_debug1(debug_, DebugTxt, 0#)
    If Not IsMissing(debug2_) Then Call BI_debug2(debug2_, 0.00001, OldTime)
    '
    '=============================================
    Atn49 = BIAtnR_BS(X49, M, debug3_, debug2_)
        '
        If Not IsMissing(debug_) Then DebugTxt = "Atn(1/57) vZEEE" & vbCr & _
                                                 "Atn(1/49) (" & BI2ExpN(Atn49, 6) & ")  vZ [" & Format(NowTime - OldTime, "#0 Sec]") & vbCr
        If Not IsMissing(debug_) Then Call BI_debug1(debug_, DebugTxt, 0#)
        If Not IsMissing(debug2_) Then Call BI_debug2(debug2_, 0.00001, OldTime)
        '
    Atn57 = BIAtnR_BS(X57, M, debug3_, debug2_)
        '
        If Not IsMissing(debug_) Then DebugTxt = "Atn(1/239) vZEEE" & vbCr & _
                                                 "Atn(1/57) (" & BI2ExpN(Atn57, 6) & ")  vZ [" & Format(NowTime - OldTime, "#0 Sec]") & vbCr
        If Not IsMissing(debug_) Then Call BI_debug1(debug_, DebugTxt, 0#)
        If Not IsMissing(debug2_) Then Call BI_debug2(debug2_, 0.00001, OldTime)
        '
    Atn239 = BIAtnR_BS(X239, M, debug3_, debug2_)
        '
        If Not IsMissing(debug_) Then DebugTxt = "Atn(1/110443) vZEEE" & vbCr & _
                                                 "Atn(1/239) (" & BI2ExpN(Atn239, 6) & ")  vZ [" & Format(NowTime - OldTime, "#0 Sec]") & vbCr
        If Not IsMissing(debug_) Then Call BI_debug1(debug_, DebugTxt, 0#)
        If Not IsMissing(debug2_) Then Call BI_debug2(debug2_, 0.00001, OldTime)
        '
    Atn110443 = BIAtnR_BS(X110443, M, debug3_, debug2_)
        '
        If Not IsMissing(debug_) Then DebugTxt = "Atn(1/49) vZEEE" & vbCr & _
                                                 "Atn(1/110443) (" & BI2ExpN(Atn110443, 6) & ")  vZ [" & Format(NowTime - OldTime, "#0 Sec]") & vbCr
        If Not IsMissing(debug_) Then Call BI_debug1(debug_, DebugTxt, 0#)
        If Not IsMissing(debug2_) Then Call BI_debug2(debug2_, 0.00001, OldTime)
        '
    TMP1 = BigIntMul(X48, Atn49, M)
        '
        If Not IsMissing(debug_) Then DebugTxt = "128*Atn(1/57) vZEEE" & vbCr & _
                                                 "48*Atn(1/49) (" & BI2ExpN(TMP1, 6) & ")  vZ [" & Format(NowTime - OldTime, "#0 Sec]") & vbCr
        If Not IsMissing(debug_) Then Call BI_debug1(debug_, DebugTxt, 0#)
        If Not IsMissing(debug2_) Then Call BI_debug2(debug2_, 0.00001, OldTime)
        '
    TMP2 = BigIntMul(X128, Atn57, M)
        '
        If Not IsMissing(debug_) Then DebugTxt = "-20*Atn(1/239) vZEEE" & vbCr & _
                                                 "128*Atn(1/57) (" & BI2ExpN(TMP2, 6) & ")  vZ [" & Format(NowTime - OldTime, "#0 Sec]") & vbCr
        If Not IsMissing(debug_) Then Call BI_debug1(debug_, DebugTxt, 0#)
        If Not IsMissing(debug2_) Then Call BI_debug2(debug2_, 0.00001, OldTime)
        '
    TMP3 = BigIntMul(X20, Atn239, M)
    TMP3.BigSgn = "-"
        '
        If Not IsMissing(debug_) Then DebugTxt = "48*Atn(1/110443) vZEEE" & vbCr & _
                                                 "-20*Atn(1/239) (" & BI2ExpN(TMP3, 6) & ")  vZ [" & Format(NowTime - OldTime, "#0 Sec]") & vbCr
        If Not IsMissing(debug_) Then Call BI_debug1(debug_, DebugTxt, 0#)
        If Not IsMissing(debug2_) Then Call BI_debug2(debug2_, 0.00001, OldTime)
        '
    TMP4 = BigIntMul(X48, Atn110443, M)
        '
        If Not IsMissing(debug_) Then DebugTxt = "WvEEE" & vbCr & _
                                                 "48*Atn(1/110443) (" & BI2ExpN(TMP4, 6) & ")  vZ [" & Format(NowTime - OldTime, "#0 Sec]") & vbCr
        If Not IsMissing(debug_) Then Call BI_debug1(debug_, DebugTxt, 0#)
        If Not IsMissing(debug2_) Then Call BI_debug2(debug2_, 0.00001, OldTime)
        '
    TMP5 = BigIntAdd(TMP1, TMP2, M)
    TMP6 = BigIntAdd(TMP5, TMP3, M)
    CC = BigIntAdd(TMP6, TMP4, M)
        '
        If Not IsMissing(debug_) Then Call BI_debug1(debug_, "Wv [" & Format(NowTime - OldTime, "#0 Sec]") & vbCr, 0#)
        If Not IsMissing(debug2_) Then Call BI_debug2(debug2_, 0.00001, OldTime)
        '
    '=============================================
    '
    CC = BIKetaN(CC, CLng(Digit))
    'ߒlZbg
    BIPiTCalc = CC
    '
    If Not IsMissing(debug2_) Then Call BI_debug2(debug2_, 0.00001, OldTime)
    '
Exit Function
ERR:
'Resume Next
    BigIntErrFLG = ERR.number
    Call BIWarnningDialog(Error(BigIntErrFLG) & vbCr & vbCr, "BIPiTCalc")
End Function
'~  /6
Public Function BIPi6Calc(Digit As Long, Optional N As Long = PaiLimitN, _
                          Optional debug_ As Variant, Optional debug2_ As Variant, Optional debug3_ As Variant) As BigIntType
'  ΁^~ [/6= (2k)!/{(2^(4k+1))*((k!)^2)*(2k+1)}]
'              arcsin(x)̃eC[WJ x=1/2 
'------------------------------------------------------------------------------
'    Digit     [Integer]     ߂錅
'        N         [Long]        iȗjőJԂvZ (ȗ pubN萔 PaiLimitN)
'        debug_    [Variant]     iȗj[U[tH[̃IuWFNg vZߒ̏o͐
'        debug2_   [Variant]     iȗj[U[tH[̃IuWFNg vZԂ̏o͐
'        debug3_   [Variant]     iȗj[U[tH[̃IuWFNg ڍׂȉߒ̏o͐
'  ߒl  I  [BigIntType]  [U[`^
'@@  @ُI  [BigIntType]  [U[`^̃G[l (BigSgn:""(ASCIIR[hԍ0), BigInt:"", BigExp:0, BigDat:Empty)
'------------------------------------------------------------------------------
'    ʏ́A\擾 BIPi ֐gp
'------------------------------------------------------------------------------
'    ȗ̍őJԂvZ 5000 [=PaiLimitN]܂
'------------------------------------------------------------------------------
'  ˑ  ֐  BICBit, BigIntAdd, BigIntMul, BigIntDiv, BIReciprocal,
'              BIIsAEqualB, BIIsError, Bigint2String, BIKetaN,
'              BIWarnningDialog,
'              DigitCheck, SetBigIntDigitCalculations,
'              Wait
'        萔  BigIntLimit
'        ϐ  BigIntErrFLG
'              NowTime
'  ̃Xg͒ڗpĂ֐E萔Eϐ̂݁iVBAg݊֐E萔j
'------------------------------------------------------------------------------
'    o[Wł͌vZx̊֌WŁA5001܂ŎZô͖ł
'        px̉ZXs[hȂ΁A1000ȉŎgpĂ
'------------------------------------------------------------------------------
'  Ql  vZ  (Pentium 4 2.80C GHz) [By Ver.1.67 BigInt_Demo(vZߒo:ON)]
'                   1000    6  x
'                   ȏ͖mF
'------------------------------------------------------------------------------
Dim CC       As BigIntType   '
Dim X0       As BigIntType   '萔  0
Dim X1       As BigIntType   '      1
Dim X6       As BigIntType   '      6
Dim X16      As BigIntType   '     16(=2^4)
Dim X02      As BigIntType   '    1/2
Dim X016     As BigIntType   '   1/16(=1/16)
Dim E0       As BigIntType   'OilPj
Dim EN       As BigIntType   'm
Dim E1       As BigIntType   'Pȍ~݌v  ̒l
Dim E10      As BigIntType   '                O̒l
Dim d        As BigIntType   'q
Dim D0       As BigIntType   '      O
Dim F1       As BigIntType   '  P  
Dim F10      As BigIntType   '              O
Dim F2       As BigIntType   '      Q  
Dim F20      As BigIntType   '              O
Dim F3       As BigIntType   '      R  
Dim TMP      As BigIntType   'vZ̉l
Dim TMP0     As BigIntType   'vZ̉l
Dim I        As Long
Dim K        As Long
Dim M        As Long         'vZ
Dim dE       As Long         'liOƌvŽj
Dim Ddm      As Long         ']TiɂU{̂Ŏ茅j[Decision-digit margin]
Dim Nnow     As Long         '݂̌vZߒo
Dim NlAst    As Long         'ǑvZߒo
Dim dDigit   As Long         ']T
Dim dStepN   As Long         'o͕px
Dim OldTime  As Single
Dim DebugTxt As String
    On Error GoTo ERR:
    '
    If Not IsMissing(debug2_) Then Call BI_debug2(debug2_, 0#, OldTime)
    '
    '߂錅̃`FbN
    If Not DigitCheck(Digit) Then Exit Function
    'őJԂvZ񐔃`FbN
    If N <= 0 Then
        BigIntErrFLG = 5
        Error BigIntErrFLG
        Exit Function
    End If
    '---------------------------------------------------------------------
    Ddm = 1       ']T
    dDigit = 5    ']T
    dStepN = 10   'o̓Xebv
    X0 = BICBit(0)
    X1 = BICBit(1)
    X6 = BICBit(6)
    X02 = BICBit(0.5)
    X016 = BICBit(0.0625)
    'vZ
    M = SetBigIntDigitCalculations(Digit, dDigit)
    '---------------------------------------------------------------------
    '
    If Not IsMissing(debug_) Then DebugTxt = "---------------------------" & vbCr & _
                                             " K : vZ" & vbCr & _
                                             " N : ~̋܂ (Pȍ~)" & vbCr & _
                                             " L : vZiPȍ~j̗L" & vbCr & _
                                             " T : vZ" & vbCr & _
                                             "---------------------------" & vbCr
    If Not IsMissing(debug_) Then Call BI_debug1(debug_, DebugTxt, 0.00001)
    If Not IsMissing(debug2_) Then Call BI_debug2(debug2_, 0.00001, OldTime)
    'ڍׂȉߒo
    If Not IsMissing(debug3_) Then Call BI_debug1(debug_, "K:0, liOj" & Bigint2String(E0) & vbCr, 0.00001)
    '
    E0 = X02    'O      l 1/2
    E1 = X0     'Pȍ~  v
    d = X1      'Pȍ~  q  D
    F1 = X02    'Pȍ~  Pځ@F1
    F2 = X1     'Pȍ~  Qځ@F2
    Call Wait(0.0001)   'DoEvents
    '[/6= (2k)!/{(2^(4k+1))*((k!)^2)*(2k+1)}]
    For K = 1 To N
        E10 = E1
        D0 = d
        F10 = F1
        F20 = F2
        '------------------------------------------------------------
        'q
        '(2k)!
        TMP = BICBit((2 * K) * (2 * K - 1))
        d = BigIntMul(D0, TMP, M)
        'i̋tj
        '(2^(4k+1))
        F1 = BigIntMul(F10, X016, M)
        '((k!)^2)
        TMP = BICBit(K)
        TMP0 = BigIntMul(TMP, TMP, M)
        TMP = BIReciprocal(TMP0, M)
        F2 = BigIntMul(F20, TMP, M)
        '(2k+1)
        TMP = BICBit(2 * K + 1)
        F3 = BIReciprocal(TMP, M)
        '
        TMP = BigIntMul(d, F1, M)
        TMP0 = BigIntMul(TMP, F2, M)
        'j
        EN = BigIntMul(TMP0, F3, M)
        '------------------------------------------------------------
        'Z
        E1 = BigIntAdd(E1, EN, M)
        'l Zo
        dE = (Len(E0.BigInt) + E0.BigExp) - (Len(EN.BigInt) + EN.BigExp)
        '------------------------------------------------------------
        If Not IsMissing(debug3_) Then
        'ڍׂȉߒo
            debug_.Value = "K:" & CStr(K) & ",EN " & Bigint2String(EN) & vbCr & debug_.Value
            debug_.SetFocus
            debug_.SelStart = 0
        End If
        If K Mod dStepN = 0 Then
            Call Wait(0.0001)   'DoEvents
            '
            If Not IsMissing(debug_) Then
                Nnow = dE
                If Nnow > NlAst + 1 Then
                    DebugTxt = "K:" & CStr(K) & _
                               ", N:" & Format(NlAst + 1, "00") & "`" & Format(Nnow, "00") & _
                               ", L:" & Len(E1.BigInt) & _
                               ", T:" & Format(NowTime - OldTime, "#0.000 Sec") & vbCr
                Else
                    DebugTxt = "K:" & CStr(K) & _
                               ", N:" & Format(Nnow, "00") & _
                               ", L:" & Len(E1.BigInt) & _
                               ", T:" & Format(NowTime - OldTime, "#0.000 Sec") & vbCr
                End If
                NlAst = Nnow
            End If
            If Not IsMissing(debug_) Then Call BI_debug1(debug_, DebugTxt, 0.00001)
            If Not IsMissing(debug2_) Then Call BI_debug2(debug2_, 0.00001, OldTime)
            '
        End If
        ' -----------------------------------------------------------
        If dE >= Digit + Ddm Then
        '
            '
            If Not IsMissing(debug_) Then
                Nnow = dE
                DebugTxt = "l 1E+" & CStr(Digit + Ddm) & "(*) ̂PȉƂȂ܂B" & vbCr & _
                           "El(O) [" & BI2ExpN(E0, 8) & "]" & vbCr & _
                           "E" & CStr(K) & " T[" & BI2ExpN(EN, 8) & "]" & vbCr & _
                           "(*):߂錅{]T [=" & CStr(Digit) & "+" & CStr(Ddm) & "]" & vbCr & _
                           "lƔfČvZI܂B" & vbCr & _
                           "I" & vbCr & _
                           "K:" & CStr(K) & _
                           ", N:" & Format(Nnow, "00") & _
                           ", L:" & Len(E1.BigInt) & _
                           ", T:" & Format(NowTime - OldTime, "#0.000 Sec") & vbCr
            End If
            If Not IsMissing(debug_) Then Call BI_debug1(debug_, DebugTxt, 0.00001)
            If Not IsMissing(debug2_) Then Call BI_debug2(debug2_, 0.00001, OldTime)
            '
            Exit For
        End If
        If BIIsAEqualB(E1, E10) Then
        'ω
            '
            If Not IsMissing(debug_) Then DebugTxt = "vZlA܂B" & vbCr & _
                                                     "I" & vbCr & vbCr
            If Not IsMissing(debug_) Then Call BI_debug1(debug_, DebugTxt, 0.00001)
            If Not IsMissing(debug2_) Then Call BI_debug2(debug2_, 0.00001, OldTime)
            '
            Exit For
        ElseIf BIIsError(E1) Then
        'G[l
            '
            If Not IsMissing(debug_) Then DebugTxt = "vZlAG[łB" & vbCr & _
                                                     "ُI" & vbCr
            If Not IsMissing(debug_) Then Call BI_debug1(debug_, DebugTxt, 0.00001)
            If Not IsMissing(debug2_) Then Call BI_debug2(debug2_, 0.00001, OldTime)
            '
            Exit Function
        ElseIf K = N Then
        'őJԂvZ
            '
            If Not IsMissing(debug_) Then
                DebugTxt = "----------------------------------" & vbCr & _
                           "̓r E0+E1:" & Bigint2String(BigIntAdd(E0, E1, Digit)) & vbCr & _
                           "----------------------------------" & vbCr & _
                           "Pȍ~̍v E1:" & Bigint2String(E1) & vbCr & _
                           "----------------------------------" & vbCr & _
                           "O E0:" & Bigint2String(E0) & vbCr & _
                           "----------------------------------" & vbCr & _
                           "őJԂvZ񐔁ilj [N:" & CStr(N) & "] ɒB܂B" & vbCr & _
                           "vZI܂B " & vbCr
            End If
            If Not IsMissing(debug_) Then Call BI_debug1(debug_, DebugTxt, 0.00001)
            If Not IsMissing(debug2_) Then Call BI_debug2(debug2_, 0.00001, OldTime)
            '
        End If
    Next K
    'viO{Pȍ~̍vj
    TMP = BigIntAdd(E0, E1, M)
    '̌vZ =(/6)*6
    TMP0 = BigIntMul(TMP, X6, M)
    '
    If Not IsMissing(debug2_) Then Call BI_debug2(debug2_, 0.00001, OldTime)
    '
    '
    CC = BIKetaN(TMP0, Digit)
    'Zbg
    BIPi6Calc = CC
    '
    If Not IsMissing(debug2_) Then Call BI_debug2(debug2_, 0.00001, OldTime)
    '
Exit Function
ERR:
'Resume Next
    BigIntErrFLG = ERR.number
    Call BIWarnningDialog(Error(BigIntErrFLG) & vbCr & vbCr, "BIPi6Calc")
End Function
'********************************************************************************************
'~  /2ŁixA肪ȒPłȂ̂ŌvZl͐mł͂܂j
Public Function BIPi2Calc(Digit As Long, Optional N As Long = PaiLimitN, _
                          Optional debug_ As Variant, Optional debug2_ As Variant, Optional debug3_ As Variant) As BigIntType
'  ΁^~ [/2= ((2k-1)!!/2k!!) /(2k+1)]
'------------------------------------------------------------------------------
'    Digit     [Integer]     ߂錅
'        N         [Long]        iȗjőJԂvZ (ȗ pubN萔 eLimitN)
'        debug_    [Variant]     iȗj[U[tH[̃IuWFNg vZߒ̏o͐
'        debug2_   [Variant]     iȗj[U[tH[̃IuWFNg vZԂ̏o͐
'        debug3_   [Variant]     iȗj[U[tH[̃IuWFNg ڍׂȉߒ̏o͐
'  ߒl  I  [BigIntType]  [U[`^ (^xKetaN̐)
'@@  @ُI  [BigIntType]  [U[`^̃G[l (BigSgn:""(ASCIIR[hԍ0), BigInt:"", BigExp:0, BigDat:Empty)
'------------------------------------------------------------------------------
'    ̉~vZŋ߂֐ŁA
'        10001i_ȉ10000j܂ŉZiߒlŎ擾jł܂
'        ʏ́A\擾 BIPi ֐gp
'------------------------------------------------------------------------------
'    ȗ̍őJԂvZ 5000 ܂
'------------------------------------------------------------------------------
'  ˑ  ֐  BICBit, BigIntAdd, BigIntMul, BigIntDiv, BIReciprocal,
'              BIIsAEqualB, BIIsError, Bigint2String, BIKetaN,
'              BIWarnningDialog,
'              DigitCheck, SetBigIntDigitCalculations,
'              Wait
'        萔  BigIntLimit, PaiLimitN
'        ϐ  BigIntErrFLG
'              NowTime
'  ̃Xg͒ڗpĂ֐E萔Eϐ̂݁iVBAg݊֐E萔j
'------------------------------------------------------------------------------
'    x̂ŁA肪mɏo܂
'        pł͂܂BʏAGMł/6łgpĂ
'------------------------------------------------------------------------------
'  Ql  vZ  (Pentium 4 2.80C GHz) [By Ver.x.xx BigInt_Demo(vZߒo:ON)]
'                   1000    x  x
'                   2000   xx    x
'                   3000  xxx    x
'                   ȏ͖mF
'------------------------------------------------------------------------------
Dim CC       As BigIntType   '
Dim X0       As BigIntType   '萔  0
Dim X1       As BigIntType   '      1
Dim X2       As BigIntType   '      2
Dim E0       As BigIntType   'OilPj
Dim EN       As BigIntType   'm
Dim E1       As BigIntType   'Pȍ~݌v  ̒l
Dim E10      As BigIntType   '                O̒l
Dim E11      As BigIntType   '          鐔  O
Dim E12      As BigIntType   '          鐔  ㍀
Dim d        As BigIntType   'q
Dim f        As BigIntType   '
Dim F1       As BigIntType   '
Dim F2       As BigIntType   '
Dim TMP      As BigIntType   'vZ̉l
Dim TMP0     As BigIntType   '
Dim I        As Long
Dim K        As Long
Dim M        As Long         'vZ
Dim dE       As Long         'liOƌvŽj
Dim Ddm      As Long         ']TiɂQ{̂Ŏ茅j[Decision-digit margin]
Dim Nnow     As Long         '݂̌vZߒo
Dim NlAst    As Long         'ǑvZߒo
Dim dDigit   As Long         ']T
Dim dStepN   As Long         'o͕px
Dim OldTime  As Single
Dim DebugTxt As String
    On Error GoTo ERR:
    '
    If Not IsMissing(debug2_) Then Call BI_debug2(debug2_, 0#, OldTime)
    '
    '߂錅̃`FbN
    If Not DigitCheck(Digit) Then Exit Function
    'őJԂvZ񐔃`FbN
    If N <= 0 Then
        BigIntErrFLG = 5
        Error BigIntErrFLG
        Exit Function
    End If
    '---------------------------------------------------------------------
    Ddm = 1       ']T
    dDigit = 5    ']T
    dStepN = 50   'o̓Xebv
    X0 = BICBit(0)
    X1 = BICBit(1)
    X2 = BICBit(2)
    'vZ
    M = SetBigIntDigitCalculations(Digit, dDigit)
    '---------------------------------------------------------------------
    '
    If Not IsMissing(debug_) Then DebugTxt = "---------------------------" & vbCr & _
                                             " K : vZ" & vbCr & _
                                             " N : ~̋܂ (Pȍ~)" & vbCr & _
                                             " L : vZiPȍ~j̗L" & vbCr & _
                                             " T : vZ" & vbCr & _
                                             "---------------------------" & vbCr
    If Not IsMissing(debug_) Then Call BI_debug1(debug_, DebugTxt, 0.00001)
    If Not IsMissing(debug2_) Then Call BI_debug2(debug2_, 0.00001, OldTime)
    'ڍׂȉߒo
    If Not IsMissing(debug3_) Then Call BI_debug1(debug_, "K:0, liOj" & Bigint2String(E0) & vbCr, 0.00001)
    '
    E0 = X1    'O      l 1
    E1 = X0    'Pȍ~  v
    E11 = X1   'Pȍ~  鐔  O
    d = X1
    f = X1
    Call Wait(0.0001)   'DoEvents
    '[/2= ((2k-1)!!/2k!!) /(2k+1)]
    For K = 1 To N
        E10 = E1
        '------------------------------------------------------------
        'O
        d = BICBit(2 * K - 1)
        TMP = BICBit(2 * K)
        f = BIReciprocal(TMP, M)
        TMP = BigIntMul(d, f, M)
        TMP0 = BigIntMul(E11, TMP, M)
        E11 = TMP0
        '㍀
        F2 = BICBit(2 * K + 1)
        E12 = BIReciprocal(F2, M)
        'j
        EN = BigIntMul(E11, E12, M)
        '------------------------------------------------------------
        'Z
        E1 = BigIntAdd(E1, EN, M)
        'l Zo
        dE = (Len(E0.BigInt) + E0.BigExp) - (Len(EN.BigInt) + EN.BigExp)
        '------------------------------------------------------------
        If Not IsMissing(debug3_) Then
        'ڍׂȉߒo
            debug_.Value = "K:" & CStr(K) & ",EN " & Bigint2String(EN) & vbCr & debug_.Value
            debug_.SetFocus
            debug_.SelStart = 0
        End If
        If K Mod dStepN = 0 Then
            Call Wait(0.0001)   'DoEvents
            '
            If Not IsMissing(debug_) Then
                Nnow = dE
                If Nnow > NlAst + 1 Then
                    DebugTxt = "K:" & CStr(K) & _
                               ", N:" & Format(NlAst + 1, "00") & "`" & Format(Nnow, "00") & _
                               ", L:" & Len(E1.BigInt) & _
                               ", T:" & Format(NowTime - OldTime, "#0.000 Sec") & vbCr
                Else
                    DebugTxt = "K:" & CStr(K) & _
                               ", N:" & Format(Nnow, "00") & _
                               ", L:" & Len(E1.BigInt) & _
                               ", T:" & Format(NowTime - OldTime, "#0.000 Sec") & vbCr
                End If
                NlAst = Nnow
            End If
            If Not IsMissing(debug_) Then Call BI_debug1(debug_, DebugTxt, 0.00001)
            If Not IsMissing(debug2_) Then Call BI_debug2(debug2_, 0.00001, OldTime)
            '
        End If
        ' -----------------------------------------------------------
        If dE >= Digit + Ddm Then
        '
            '
            If Not IsMissing(debug_) Then
                Nnow = dE
                DebugTxt = "l 1E+" & CStr(Digit + Ddm) & "(*) ̂PȉƂȂ܂B" & vbCr & _
                           "El(O) [" & BI2ExpN(E0, 8) & "]" & vbCr & _
                           "E" & CStr(K) & " T[" & BI2ExpN(EN, 8) & "]" & vbCr & _
                           "(*):߂錅{]T [=" & CStr(Digit) & "+" & CStr(Ddm) & "]" & vbCr & _
                           "x̂ŌvZł؂肪mɔfo܂̂ŁAŌvZł؂܂B" & vbCr & _
                           "IłvZl͐młȂ\ł" & vbCr & _
                           "K:" & CStr(K) & _
                           ", N:" & Format(Nnow, "00") & _
                           ", L:" & Len(E1.BigInt) & _
                           ", T:" & Format(NowTime - OldTime, "#0.000 Sec") & vbCr
            End If
            If Not IsMissing(debug_) Then Call BI_debug1(debug_, DebugTxt, 0.00001)
            If Not IsMissing(debug2_) Then Call BI_debug2(debug2_, 0.00001, OldTime)
            '
            Exit For
        End If
        If BIIsAEqualB(E1, E10) Then
        'ω
            '
            If Not IsMissing(debug_) Then DebugTxt = "vZlA܂B" & vbCr & _
                                                     "I" & vbCr & vbCr
            If Not IsMissing(debug_) Then Call BI_debug1(debug_, DebugTxt, 0.00001)
            If Not IsMissing(debug2_) Then Call BI_debug2(debug2_, 0.00001, OldTime)
            '
            Exit For
        ElseIf BIIsError(E1) Then
        'G[l
            '
            If Not IsMissing(debug_) Then DebugTxt = "vZlAG[łB" & vbCr & _
                                                     "ُI" & vbCr
            If Not IsMissing(debug_) Then Call BI_debug1(debug_, DebugTxt, 0.00001)
            If Not IsMissing(debug2_) Then Call BI_debug2(debug2_, 0.00001, OldTime)
            '
            Exit Function
        ElseIf K = N Then
        'őJԂvZ
            '
            If Not IsMissing(debug_) Then
                DebugTxt = "----------------------------------" & vbCr & _
                           "̓r E0+E1:" & Bigint2String(BigIntAdd(E0, E1, Digit)) & vbCr & _
                           "----------------------------------" & vbCr & _
                           "Pȍ~̍v E1:" & Bigint2String(E1) & vbCr & _
                           "----------------------------------" & vbCr & _
                           "O E0:" & Bigint2String(E0) & vbCr & _
                           "----------------------------------" & vbCr & _
                           "őJԂvZ񐔁ilj [N:" & CStr(N) & "] ɒB܂B" & vbCr & _
                           "vZI܂B " & vbCr
            End If
            If Not IsMissing(debug_) Then Call BI_debug1(debug_, DebugTxt, 0.00001)
            If Not IsMissing(debug2_) Then Call BI_debug2(debug2_, 0.00001, OldTime)
            '
        End If
    Next K
    'viO{Pȍ~̍vj
    TMP = BigIntAdd(E0, E1, Digit)
    '̌vZ =(/2)*2
    TMP0 = BigIntMul(TMP, X2, Digit)
    '
    If Not IsMissing(debug2_) Then Call BI_debug2(debug2_, 0.00001, OldTime)
    '
    '
    CC = BIKetaN(TMP0, Digit)
    'ߒlZbg
    BIPi2Calc = CC
    '
    If Not IsMissing(debug2_) Then Call BI_debug2(debug2_, 0.00001, OldTime)
    '
Exit Function
ERR:
'Resume Next
    BigIntErrFLG = ERR.number
    Call BIWarnningDialog(Error(BigIntErrFLG) & vbCr & vbCr, "BIPi2Calc")
End Function
'~  /4ŁixA肪ȒPłȂ̂ŌvZl͐mł͂܂j
Public Function BIPi4Calc(Digit As Long, Optional N As Long = PaiLimitN, _
                          Optional debug_ As Variant, Optional debug2_ As Variant, Optional debug3_ As Variant) As BigIntType
'  ΁^~ [/4=(-1)^k(1/(2k+1))] }`̌
'------------------------------------------------------------------------------
'    Digit     [Integer]     ߂錅
'        N         [Long]        iȗjőJԂvZ (ȗ pubN萔 eLimitN)
'        debug_    [Variant]     iȗj[U[tH[̃IuWFNg vZߒ̏o͐
'        debug2_   [Variant]     iȗj[U[tH[̃IuWFNg vZԂ̏o͐
'        debug3_   [Variant]     iȗj[U[tH[̃IuWFNg ڍׂȉߒ̏o͐
'  ߒl  I  [BigIntType]  [U[`^ (^xKetaN̐)
'@@  @ُI  [BigIntType]  [U[`^̃G[l (BigSgn:""(ASCIIR[hԍ0), BigInt:"", BigExp:0, BigDat:Empty)
'------------------------------------------------------------------------------
'    ʏ́A\擾 BIPi ֐gp
'------------------------------------------------------------------------------
'    ȗ̍őJԂvZ 5000 ܂
'------------------------------------------------------------------------------
'  ˑ  ֐  BICBit, BigIntAdd, BigIntMul, BigIntDiv, BIReciprocal,
'              BIIsAEqualB, BIIsError, Bigint2String, BIKetaN,
'              BIWarnningDialog,
'              DigitCheck, SetBigIntDigitCalculations,
'              Wait
'        萔  BigIntLimit, PaiLimitN
'        ϐ  BigIntErrFLG
'              NowTime
'  ̃Xg͒ڗpĂ֐E萔Eϐ̂݁iVBAg݊֐E萔j
'------------------------------------------------------------------------------
'    x̂ŁA肪mɏo܂
'        pł͂܂BʏAGMł/6łgpĂ
'------------------------------------------------------------------------------
'  Ql  vZ  mF
'------------------------------------------------------------------------------
Dim CC       As BigIntType   '
Dim X0       As BigIntType   '萔  0
Dim X1       As BigIntType   '      1
Dim X4       As BigIntType   '      2
Dim E0       As BigIntType   'OilPj
Dim EN       As BigIntType   'm
Dim E1       As BigIntType   'Pȍ~݌v  ̒l
Dim E10      As BigIntType   '                O̒l
Dim f        As BigIntType   '
Dim TMP      As BigIntType   'vZ̉l
Dim TMP0     As BigIntType   'vZ̉l
Dim I        As Long
Dim K        As Long
Dim M        As Long         'vZ
Dim dE       As Long         'liOƌvŽj
Dim Ddm      As Long         ']TiɂS{̂Ŏ茅j[Decision-digit margin]
Dim Nnow     As Long         '݂̌vZߒo
Dim NlAst    As Long         'ǑvZߒo
Dim dDigit   As Long         ']T
Dim dStepN   As Long         'o͕px
Dim OldTime  As Single
Dim DebugTxt As String
    On Error GoTo ERR:
    '
    If Not IsMissing(debug2_) Then Call BI_debug2(debug2_, 0#, OldTime)
    '
    '߂錅̃`FbN
    If Not DigitCheck(Digit) Then Exit Function
    'őJԂvZ񐔃`FbN
    If N <= 0 Then
        BigIntErrFLG = 5
        Error BigIntErrFLG
        Exit Function
    End If
    '---------------------------------------------------------------------
    Ddm = 1       ']T
    dDigit = 5    ']T
    dStepN = 50   'o̓Xebv
    X0 = BICBit(0)
    X1 = BICBit(1)
    X4 = BICBit(4)
    'vZ
    M = SetBigIntDigitCalculations(Digit, dDigit)
    '---------------------------------------------------------------------
    '
    If Not IsMissing(debug_) Then DebugTxt = "---------------------------" & vbCr & _
                                             " K : vZ" & vbCr & _
                                             " N : ~̋܂ (Pȍ~)" & vbCr & _
                                             " L : vZiPȍ~j̗L" & vbCr & _
                                             " T : vZ" & vbCr & _
                                             "---------------------------" & vbCr
    If Not IsMissing(debug_) Then Call BI_debug1(debug_, DebugTxt, 0.00001)
    If Not IsMissing(debug2_) Then Call BI_debug2(debug2_, 0.00001, OldTime)
    'ڍׂȉߒo
    If Not IsMissing(debug3_) Then Call BI_debug1(debug_, "K:0, liOj" & Bigint2String(E0) & vbCr, 0.00001)
    '
    E0 = X1    'O      l 1
    EN = X0    'Pȍ~  ̉Z
    E1 = X0    'Pȍ~  v
    E10 = X0   'Pȍ~  OE1
    Call Wait(0.0001)   'DoEvents
    '[/4=(-1)^k(1/(2k+1))]
    For K = 1 To N
        E10 = E1
        '------------------------------------------------------------
        f = BICBit(2 * K + 1)
        'j
        EN = BIReciprocal(f, M)
        If K Mod 2 = 1 Then
            EN.BigSgn = "-"
        End If
        '------------------------------------------------------------
        'Z
        E1 = BigIntAdd(E1, EN, M)
        'l Zo
        dE = (Len(E0.BigInt) + E0.BigExp) - (Len(EN.BigInt) + EN.BigExp)
        '------------------------------------------------------------
        If Not IsMissing(debug3_) Then
        'ڍׂȉߒo
            debug_.Value = "K:" & CStr(K) & ", " & Bigint2String(EN) & vbCr & debug_.Value
            debug_.SetFocus
            debug_.SelStart = 0
        End If
        If K Mod dStepN = 0 Then
            Call Wait(0.0001)   'DoEvents
            '
            If Not IsMissing(debug_) Then
                Nnow = dE
                If Nnow > NlAst + 1 Then
                    DebugTxt = "K:" & CStr(K) & _
                               ", N:" & Format(NlAst + 1, "00") & "`" & Format(Nnow, "00") & _
                               ", L:" & Len(E1.BigInt) & _
                               ", T:" & Format(NowTime - OldTime, "#0.000 Sec") & vbCr
                Else
                    DebugTxt = "K:" & CStr(K) & _
                               ", N:" & Format(Nnow, "00") & _
                               ", L:" & Len(E1.BigInt) & _
                               ", T:" & Format(NowTime - OldTime, "#0.000 Sec") & vbCr
                End If
                NlAst = Nnow
            End If
            If Not IsMissing(debug_) Then Call BI_debug1(debug_, DebugTxt, 0.00001)
            If Not IsMissing(debug2_) Then Call BI_debug2(debug2_, 0.00001, OldTime)
            '
        End If
        ' -----------------------------------------------------------
        If dE >= Digit + Ddm Then
        '
            '
            If Not IsMissing(debug_) Then
                Nnow = dE
                DebugTxt = "l 1E+" & CStr(Digit + Ddm) & "(*) ̂PȉƂȂ܂B" & vbCr & _
                           "El(O) [" & BI2ExpN(E0, 8) & "]" & vbCr & _
                           "E" & CStr(K) & " T[" & BI2ExpN(EN, 8) & "]" & vbCr & _
                           "(*):߂錅{]T [=" & CStr(Digit) & "+" & CStr(Ddm) & "]" & vbCr & _
                           "x̂ŌvZł؂肪mɔfo܂̂ŁAŌvZł؂܂B" & vbCr & _
                           "IłvZl͐młȂ\ł" & vbCr & _
                           "K:" & CStr(K) & _
                           ", N:" & Format(Nnow, "00") & _
                           ", L:" & Len(E1.BigInt) & _
                           ", T:" & Format(NowTime - OldTime, "#0.000 Sec") & vbCr
            End If
            If Not IsMissing(debug_) Then Call BI_debug1(debug_, DebugTxt, 0.00001)
            If Not IsMissing(debug2_) Then Call BI_debug2(debug2_, 0.00001, OldTime)
            '
            Exit For
        End If
        If BIIsAEqualB(E1, E10) Then
        'ω
            '
            If Not IsMissing(debug_) Then DebugTxt = "vZlA܂B" & vbCr & _
                                                     "I" & vbCr & vbCr
            If Not IsMissing(debug_) Then Call BI_debug1(debug_, DebugTxt, 0.00001)
            If Not IsMissing(debug2_) Then Call BI_debug2(debug2_, 0.00001, OldTime)
            '
            Exit For
        ElseIf BIIsError(E1) Then
        'G[l
            '
            If Not IsMissing(debug_) Then DebugTxt = "vZlAG[łB" & vbCr & _
                                                     "ُI" & vbCr
            If Not IsMissing(debug_) Then Call BI_debug1(debug_, DebugTxt, 0.00001)
            If Not IsMissing(debug2_) Then Call BI_debug2(debug2_, 0.00001, OldTime)
            '
            Exit Function
        ElseIf K = N Then
        'őJԂvZ
            '
            If Not IsMissing(debug_) Then
                DebugTxt = "----------------------------------" & vbCr & _
                           "̓r E0+E1:" & Bigint2String(BigIntAdd(E0, E1, Digit)) & vbCr & _
                           "----------------------------------" & vbCr & _
                           "Pȍ~̍v E1:" & Bigint2String(E1) & vbCr & _
                           "----------------------------------" & vbCr & _
                           "O E0:" & Bigint2String(E0) & vbCr & _
                           "----------------------------------" & vbCr & _
                           "őJԂvZ񐔁ilj [N:" & CStr(N) & "] ɒB܂B" & vbCr & _
                           "vZI܂B " & vbCr
            End If
            If Not IsMissing(debug_) Then Call BI_debug1(debug_, DebugTxt, 0.00001)
            If Not IsMissing(debug2_) Then Call BI_debug2(debug2_, 0.00001, OldTime)
            '
        End If
    Next K
    'viO{Pȍ~̍vj
    TMP = BigIntAdd(E0, E1, Digit)
    '̌vZ =(/4)*4
    TMP0 = BigIntMul(TMP, X4, Digit)
    '
    If Not IsMissing(debug2_) Then Call BI_debug2(debug2_, 0.00001, OldTime)
    '
    '
    CC = BIKetaN(TMP0, Digit)
    'ߒlZbg
    BIPi4Calc = CC
    '
    If Not IsMissing(debug2_) Then Call BI_debug2(debug2_, 0.00001, OldTime)
    '
Exit Function
ERR:
'Resume Next
    BigIntErrFLG = ERR.number
    Call BIWarnningDialog(Error(BigIntErrFLG) & vbCr & vbCr, "BIPi4Calc")
End Function
